#include <iostream>
#include <vector>
#include <set>

using namespace std;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int h, w, d;
    cin >> h >> w >> d;
    if (d == 1) {
        cout << "2\n0\n4\n4\n";
    }
    else {
        vector<vector<char>> pole(h + 2, vector<char>(w + 2, '#'));
        int x, y;
        for (int i = 1; i <= h; ++i) {
            for (int j = 1; j <= w; ++j) {
                cin >> pole[i][j];
                if (pole[i][j] == 'S') {
                    x = i;
                    y = j;
                }
            }
        }
        vector<set<int>> wallh(h + 2), wallw(w + 2);
        for (int i = 0; i < h + 2; ++i) {
            for (int j = 0; j < w + 2; ++j) {
                if (pole[i][j] == '#') {
                    wallh[i].insert(j);
                    wallw[j].insert(i);
                }
            }
        }
        int q;
        cin >> q;
        char type;
        while (q--) {
            cin >> type;
            if (type == 'U') {
                auto it = wallw[y].lower_bound(x);
                --it;
                int newx = *it + 1;
                cout << x - newx << "\n";
                x = newx;
            }
            else if (type == 'R') {
                auto it = wallh[x].lower_bound(y);
                int newy = *it - 1;
                cout << newy - y << "\n";
                y = newy;
            }
            else if (type == 'D') {
                auto it = wallw[y].lower_bound(x);
                int newx = *it - 1;
                cout << newx - x << "\n";
                x = newx;
            }
            else {
                auto it = wallh[x].lower_bound(y);
                --it;
                int newy = *it + 1;
                cout << y - newy << "\n";
                y = newy;
            }
        }
    }

    return 0;
}
