#include<iostream>
#include<vector>
#include<algorithm>
#include<cmath>
#include<set>
#include<map>
#include<string>
using namespace std;

#define ll long long
#define all(a) a.begin(),a.end()

template<typename T>
istream& operator >>(istream& cin, vector<T>& v) {
	for (auto& i : v)
		cin >> i;
	return cin;
}

template<typename T>
ostream& operator <<(istream& cout, vector<T>& v) {
	for (auto& i : v)
		cout << i << ' ';
	return cout;
}
int main() {
	int n;
	cin >> n;
	map<string, set<string>> mp;
	map<string, int> used;
	string emp;
	for (int i = 0; i < n; i++) {
		string u, v;
		cin >> u >> emp >> v;
		mp[u].insert(v);
	}
	int q;
	cin >> q;
	while (q--) {
		char cmd;
		cin >> cmd;
		if (cmd == '+') {
			string u, v;
			cin >> u >> emp >> v;
			mp[u].insert(v);
		}
		else {
			used.clear();
			string v;
			cin >> v;
			while (mp[v].size()) {
				if (mp[v].size() > 1) {
					v = "TOO COMPLEX";
					break;
				}
				if (used[v]) {
					v = "INFINITE LOOP";
					break;
				}
				string get = *mp[v].begin();
				used[v] = 1;
				if (v == get)
					break;
				v = get;
			}
			cout << v << '\n';
		}
	}
	//system("pause");
}