//Komershan
//@defineintlonglong (telegramm channel)
#include <iostream>
#include <vector>
#include <algorithm>
#include <stack>
#include <string>
#include <cmath>
#include <queue>
#include <set>
#include <map>
using namespace std;

//for coding
typedef long long ll;
typedef long double ld;
#define all(x) x.begin(), x.end()
#define rd(x) for (auto &i : x) cin >> i;
#define rep(i, l, r) for (int i = (l); i < (r); i++)

//for debug
#define ct(x) for (auto &i : x) cout << i << ' ';

#define int long long

signed main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int h, w, d;
	cin >> h >> w >> d;
	vector <set <int>> first(h), second(w);
	pair <int, int> begin;
	vector <vector <char>> matrix(h, vector <char>(w));
	for (int i = 0; i < h; i++) {
		for (int j = 0; j < w; j++) {
			char symb;
			cin >> symb;
			matrix[i][j] = symb;
			if (symb == 'S')
				begin = { i, j };
			else if (symb == '#') {
				first[i].insert(j);
				second[j].insert(i);
			}
		}
	}
	for (int i = 0; i < h; i++) {
		first[i].insert(-1);
		first[i].insert(w);
	}
	for (int i = 0; i < w; i++) {
		second[i].insert(-1);
		second[i].insert(h);
	}
	int n;
	cin >> n;
	string s;
	cin >> s;
	if (d == 1) {
		int bal = 0;
		for (int i = 0; i < n; i++) {
			pair <int, int> past = begin;
			if (s[i] == 'U') {
				while (begin.first > 0) {
					if (matrix[begin.first - 1][begin.second] == 'K') {
						begin.first--;
						matrix[begin.first][begin.second] = '.';
						bal++;
					}
					else if (matrix[begin.first - 1][begin.second] == 'L') {
						if (bal) {
							begin.first--;
							matrix[begin.first][begin.second] = '.';
							bal--;
						}
						else
							break;
					}
					else if (matrix[begin.first - 1][begin.second] == '#')
						break;
					else
						begin.first--;
				}
			}
			else if (s[i] == 'D') {
				while (begin.first < h - 1) {
					if (matrix[begin.first + 1][begin.second] == 'K') {
						begin.first++;
						matrix[begin.first][begin.second] = '.';
						bal++;
					}
					else if (matrix[begin.first + 1][begin.second] == 'L') {
						if (bal) {
							begin.first++;
							matrix[begin.first][begin.second] = '.';
							bal--;
						}
						else
							break;
					}
					else if (matrix[begin.first + 1][begin.second] == '#')
						break;
					else
						begin.first++;
				}
			}
			else if (s[i] == 'L') {
				while (begin.second > 0) {
					if (matrix[begin.first][begin.second - 1] == 'K') {
						begin.second--;
						matrix[begin.first][begin.second] = '.';
						bal++;
					}
					else if (matrix[begin.first][begin.second - 1] == 'L') {
						if (bal) {
							begin.second--;
							matrix[begin.first][begin.second] = '.';
							bal--;
						}
						else
							break;
					}
					else if (matrix[begin.first][begin.second - 1] == '#')
						break;
					else
						begin.second--;
				}
			}
			else {
				while (begin.second < w - 1) {
					if (matrix[begin.first][begin.second + 1] == 'K') {
						begin.second++;
						matrix[begin.first][begin.second] = '.';
						bal++;
					}
					else if (matrix[begin.first][begin.second + 1] == 'L') {
						if (bal) {
							begin.second++;
							matrix[begin.first][begin.second] = '.';
							bal--;
						}
						else
							break;
					}
					else if (matrix[begin.first][begin.second + 1] == '#')
						break;
					else
						begin.second++;
				}
			}
			cout << abs(begin.first - past.first) + abs(begin.second - past.second) << '\n';
		}
	}
	else {
		for (int i = 0; i < n; i++) {
			if (s[i] == 'U') {
				set <int> ::iterator it = second[begin.second].lower_bound(begin.first);
				while (*it > begin.first)
					it--;
				cout << begin.first - (*it + 1) << '\n';
				begin.first = (*it + 1);
			}
			else if (s[i] == 'D') {
				set <int> ::iterator it = second[begin.second].upper_bound(begin.first);
				while (*it < begin.first)
					it++;
				cout << (*it - 1) - begin.first << '\n';
				begin.first = (*it - 1);
			}
			else if (s[i] == 'L') {
				set <int> ::iterator it = first[begin.first].lower_bound(begin.second);
				while (*it > begin.second)
					it--;
				cout << begin.second - (*it + 1) << '\n';
				begin.second = (*it + 1);
			}
			else {
				set <int> ::iterator it = first[begin.first].upper_bound(begin.second);
				while (*it < begin.second)
					it++;
				cout << (*it - 1) - begin.second << '\n';
				begin.second = (*it - 1);
			}
		}
	}
}