#include <bits/stdc++.h>

template<typename T>
void __read(T &a) { std::cin >> a; }

template<typename T, typename ... Args>
void __read(T &a, Args &... args) {
    std::cin >> a;
    __read(args...);
}

#define int long long
#define ld long double
#define VI std::vector<int>
#define VPI std::vector<PII>
#define VVI std::vector<VI>
#define PII std::pair<int, int>
#define f(n) for (int i = 0; i < n; i++)
#define FOR(i, n) for (int i = 0; i < n; i++)
#define make(t, ...) t __VA_ARGS__; __read(__VA_ARGS__)
#define makev(name, n) VI name(n); f(n) std::cin >> name[i]
#define makeVVI(name, n, m) VVI name(n, VI(m)); f(n) FOR(j, m) std::cin >> name[i][j]
#define ALL(q) q.begin(), q.end()
#define RALL(q) q.rbegin(), q.rend()

#define M7 1000000007
#define MFFT 998244353
#define INF 2000000000000000001
#define PI 3.14159265359

using namespace std;

void solve() {
    make(int, n);
    if (n > 1000) {
        map<string, string> gr;
        f(n) {
            make(string, a, c, b);
            if (a != b)
                gr[a] = b;
        }
        make(int, T);
        while (T--) {
            make(string, type);
            if (type == "+") {
                make(string, a, c, b);
                if (a != b)
                    gr[a] = b;
            } else {
                make(string, s);
                string a = s;
                while (!gr.count(a))
                    a = gr[a];
                cout << a << '\n';
                while (!gr.count(s)) {
                    string to = gr[s];
                    gr[s] = a;
                    s = to;
                }
            }

        }
        return;
    }
    map<string, int> ind;
    map<int, string> rev;
    vector<set<int>> gr(1000);
    f(n) {
        make(string, a, c, b);
        int x = 0;
        int y = 0;
        if (ind.count(a))
            x = ind[a];
        else {
            x = ind.size();
            ind[a] = x;
            rev[x] = a;
        }
        if (ind.count(b))
            y = ind[b];
        else {
            y = ind.size();
            ind[b] = y;
            rev[y] = b;
        }
        if (!gr[x].count(y))
            gr[x].insert(y);
    }

    make(int, T);

    while (T--) {
        make(char, type);
        if (type == '+') {
            make(string, a, c, b);
            int x = 0;
            int y = 0;
            {
                if (ind.count(a))
                    x = ind[a];
                else {
                    x = ind.size();
                    ind[a] = x;
                    rev[x] = a;
                }
                if (ind.count(b))
                    y = ind[b];
                else {
                    y = ind.size();
                    ind[b] = y;
                    rev[y] = b;
                }
            }
            if (!gr[x].count(y))
                gr[x].insert(y);
        } else {
            make(string, a);
            int x = 0;
            if (ind.count(a))
                x = ind[a];
            else {
                x = ind.size();
                ind[a] = x;
                rev[x] = a;
            }
            set<int> vis;
            int state = 0;
            function<int(int)> dfs = [&](int v) -> int {
                if (vis.count(v)) {
                    state = 1;
                    return 0;
                }
                vis.insert(v);
                if (gr[v].size() > 1) {
                    state = 2;
                    return 0;
                }
                if (gr[v].size() == 1) {
                    if (v == *gr[v].begin())
                        return v;
                    return dfs(*gr[v].begin());
                }
                return v;
            };
            int ans = dfs(x);
            if (state == 0) {
                cout << rev[ans] << '\n';
            } else if (state == 1) {
                cout << "INFINITE LOOP\n";
            } else {
                cout << "TOO COMPLEX\n";
            }

        }
    }
}

signed main(signed argc, char **argv) {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    if (argc > 1 && (string) argv[1] == "local") {
        freopen("output.txt", "w", stdout);
        freopen("input.txt", "r", stdin);
    }
    solve();
    return 0;
}