#include <iostream>
#include <set>
#include <algorithm>
#include <vector>
#include <random>
#include <ctime>
#include <map>
#include <unordered_map>

using namespace std;
#define null nullptr

struct node {
    node* to;
    node* par;
    string val;

    node() : to(this), par(this){}
    node(string s) : to(this), par(this), val(s) {}
};

map<string, node*> mp;

void add_el(string s) {
    if (mp.find(s) == mp.end()) {
        mp[s] = new node(s);
    }
}

node* getpar(node* cr) {
    if (cr->to == cr) return cr;
    node* res = getpar(cr->to);
    cr->to = res;
    return res;
}

signed main() {
    int n;
    cin >> n;
    for (int i = 0; i < n; i++) {
        string s1, s2, ss;
        cin >> s1 >> ss >> s2;
        add_el(s1);
        add_el(s2);
        mp[s1]->to = mp[s2];
        mp[s1]->par = mp[s2];
    }
    cin >> n;
    while (n--) {
        char c;
        cin >> c;
        if (c == '+') {
            string s1, s2, ss;
            cin >> s1 >> ss >> s2;
            add_el(s1);
            add_el(s2);
            mp[s1]->to = mp[s2];
            mp[s1]->par = mp[s2];
        } else {
            string s;
            cin >> s;
            add_el(s);
            cout << getpar(mp[s])->val << '\n';
        }
    }
    return 0;
}
