#include <iostream>
#include <set>
#include <algorithm>
#include <vector>
#include <random>
#include <ctime>
#include <map>
#include <unordered_map>

using namespace std;
#define null nullptr
#pragma GCC optimize("O3")

const inline bool hit(const int& x, const int& y, const int& xt, const int& yt) {
    return (!(x == xt && y == yt)) && (x == xt || y == yt || abs(x - xt) == abs(y - yt));
}

signed main() {
    int t;
    cin >> t;
    while (t--) {
        int m, n;
        cin >> m >> n;
        n--;
        int x, y;
        cin >> x >> y;
        vector<pair<int, int>> var;
        var.reserve(m * 5);
        for (int i = 0; i < m; i++) {
            for (int j = 0; j < m; j++) {
                if (hit(x,y,i,j)) {
                    var.push_back({i, j});
                }
            }
        }
        for (int i = 0; i < n; i++) {
            vector<pair<int, int>> nvars;
            nvars.reserve(var.size());
            cin >> x >> y;
            for (auto par : var) {
                if (hit(par.first, par.second, x, y)) {
                    nvars.push_back(par);
                }
            }
            var = nvars;
        }
        cout << var.size() << '\n';
    }
    return 0;
}
