#include <iostream>
#include <vector>

using namespace std;

vector<vector<int>> cnt, gr, v;
vector<bool> used;

void solve(int a)
{
	if (used[a]) return;
	used[a] = true;
	for (int i = 1; i <= v[a][1]; ++i) cnt[a][i] = v[a][2];
	for (int to : gr[a])
	{
		solve(to);
		for (int i = 1; i <= v[to][1]; ++i) cnt[a][i] = max(cnt[a][i], cnt[to][i]);
	}
}

int main()
{
	int n;
	cin >> n;
	v.resize(n, vector<int>(3));
	used.resize(n);
	gr.resize(n);
	cnt.resize(n, vector<int>(101));
	for (int i = 0; i < n; ++i)
	{
		for (int j = 0; j < 3; ++j) cin >> v[i][j];
		--v[i][0];
		if (v[i][0] != -1) gr[v[i][0]].push_back(i);
	}
	for (int i = 0; i < n; ++i)
	{
		solve(i);
		int res = 0;
		for (int j = 1; j <= 100; ++j) res += cnt[i][j];
		cout << res << '\n';
	}
}