#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <string>
#include <cmath>
#include <stdio.h>
#include <unordered_set>
#include <deque>
#include <unordered_map>
#include <ctime>
#include <fstream>
#include <iomanip>
#define int long long
using namespace std;

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int h, w, ddd;
	cin >> h >> w >> ddd;
	vector <string> a;
	vector <set <int> > keys(h);
	vector <set<int> > doors(h);
	vector <set <int> > kk(w);
	vector <set <int> > dd(w);
	int x, y;
	for (int i = 0; i < h; ++i) {
		string s;
		cin >> s;
		a.push_back(s);
		for (int j = 0; j < w; ++j) {
			if (s[j] == 'S') {
				x = i;
				y = j;
			}
			if (s[j] == 'L') {
				doors[i].insert(j);
				dd[j].insert(i);
			}
			if (s[j] == 'K') {
				keys[i].insert(j);
				kk[j].insert(i);
			}
		}
	}
	vector <vector <int> > d(h, vector <int>(w, 0));
	vector <vector <int> > u(h, vector <int>(w, 0));
	vector <vector <int> > l(h, vector <int>(w, 0));
	vector <vector <int> > r(h, vector <int>(w, 0));
	for (int i = 0; i < h; ++i) {
		int p = 0;
		for (int j = 0; j < w; ++j) {
			l[i][j] = p;
			if (a[i][j] != '#') {
				p++;
			}
			else {
				p = 0;
			}
		}
	}
	for (int i = 0; i < h; ++i) {
		int p = 0;
		for (int j = w - 1; j >= 0; --j) {
			r[i][j] = p;
			if (a[i][j] != '#') {
				p++;
			}
			else {
				p = 0;
			}
		}
	}
	for (int j = 0; j < w; ++j) {
		int p = 0;
		for (int i = 0; i < h; ++i) {
			u[i][j] = p;
			if (a[i][j] != '#') {
				p++;
			}
			else {
				p = 0;
			}
		}
	}
	for (int j = 0; j < w; ++j) {
		int p = 0;
		for (int i = 0; i < h; ++i) {
			u[i][j] = p;
			if (a[i][j] != '#') {
				p++;
			}
			else {
				p = 0;
			}
		}
	}
	for (int j = 0; j < w; ++j) {
		int p = 0;
		for (int i = h - 1; i >= 0; --i) {
			d[i][j] = p;
			if (a[i][j] != '#') {
				p++;
			}
			else {
				p = 0;
			}
		}
	}
	int yy;
	cin >> yy;
	string z;
	cin >> z;
	int bal = 0;
	for (int q = 0; q < z.size(); ++q) {
		char c = z[q];
		if (c == 'R') {
			int mxy = r[x][y] + y;
			auto it1 = doors[x].lower_bound(y);
			auto it2 = keys[x].lower_bound(y);
			while (((it1 != doors[x].end() && *it1 <= mxy) || (it2 != keys[x].end() && *it2 <= mxy))) {
				int zn1 = 1e9;
				int zn2 = 1e9;
				if (it1 != doors[x].end()) {
					zn1 = *it1;
				}
				if (it2 != keys[x].end()) {
					zn2 = *it2;
				}
				if (zn1 < zn2 && bal == 0) {
					mxy = zn1 - 1;
					break;
				}
				if (zn1 < zn2) {
					bal--;
					dd[*it1].erase(x);
					it1 = doors[x].erase(it1);
				}
				else {
					bal++;
					kk[*it2].erase(x);
					it2 = keys[x].erase(it2);
				}
			}
			cout << mxy - y << "\n";
			y = mxy;
		}
		if (c == 'D') {
			int mxy = d[x][y] + x;
			auto it1 = dd[y].lower_bound(x);
			auto it2 = kk[y].lower_bound(x);
			while (((it1 != dd[y].end() && *it1 <= mxy) || (it2 != kk[y].end() && *it2 <= mxy))) {
				int zn1 = 1e9;
				int zn2 = 1e9;
				if (it1 != dd[y].end()) {
					zn1 = *it1;
				}
				if (it2 != kk[y].end()) {
					zn2 = *it2;
				}
				if (zn1 < zn2 && bal == 0) {
					mxy = zn1 - 1;
					break;
				}
				if (zn1 < zn2) {
					bal--;
					doors[*it1].erase(y);
					it1 = dd[y].erase(it1);
				}
				else {
					bal++;
					keys[*it2].erase(y);
					it2 = kk[y].erase(it2);
				}
			}
			cout << mxy - x << "\n";
			x = mxy;
		}
		if (c == 'L') {
			int mxy = y - l[x][y];
			auto it1 = doors[x].upper_bound(y);
			auto it2 = keys[x].upper_bound(y);
			while (((it1 != doors[x].begin()) || (it2 != keys[x].begin()))) {

				int zn1 = -1;
				int zn2 = -1;
				auto it3 = it1;
				auto it4 = it2;
				if (it1 != doors[x].begin()) {
					it3 = it1;
					it3--;
					zn1 = *it3;
				}
				if (it2 != keys[x].begin()) {
					it4 = it2;
					it4--;
					zn2 = *it4;
				}
				if (max(zn1, zn2) < mxy) {
					break;
				}
				if (zn1 > zn2 && bal == 0) {
					mxy = zn1 + 1;
					break;
				}
				if (zn1 > zn2) {
					bal--;
					dd[*it3].erase(x);
					doors[x].erase(it3);
				}
				else {
					bal++;
					kk[*it4].erase(x);
					keys[x].erase(it4);
				}
			}
			cout << y - mxy << "\n";
			y = mxy;
		}
		if (c == 'U') {
			int mxy = x - u[x][y];
			auto it1 = dd[y].upper_bound(x);
			auto it2 = kk[y].upper_bound(x);
			while (((it1 != dd[y].begin()) || (it2 != kk[y].begin()))) {
				int zn1 = -1;
				int zn2 = -1;
				auto it3 = it1;
				auto it4 = it2;
				if (it1 != dd[y].begin()) {
					it3--;

					zn1 = *it3;
				}
				if (it2 != kk[y].begin()) {
					it4--;
					zn2 = *it4;
				}
				if (max(zn1, zn2) < mxy) {
					break;
				}
				if (zn1 > zn2 && bal == 0) {
					mxy = zn1 + 1;
					break;
				}
				if (zn1 > zn2) {
					bal--;
					doors[*it3].erase(y);
					dd[y].erase(it3);
				}
				else {
					bal++;
					keys[*it4].erase(y);
					kk[y].erase(it4);
				}
			}
			cout << x - mxy << "\n";
			x = mxy;
		}
	}
}
/*
vuzak2021final-17
7yXxkZ8FaF
*/