#include <iostream>
#include <vector>
#include <queue>
#include <map>

using namespace std;
typedef long long ll;

const ll ma = 50000;
vector<ll> g[ma];

pair<ll, ll> my[ma];
ll an[ma];

vector<pair<ll, ll>> dfs(ll v) {
    vector<pair<ll, ll>> now = {my[v]};
    for (auto x :g[v]) {
        vector<pair<ll, ll>> tmp = dfs(x);
        for (auto x:tmp) {
            now.push_back(x);
        }
    }
    sort(now.begin(), now.end());
    ll Ym = 0, Xp = now.back().first;
    for (int i = now.size(); i >= 0; --i) {
        ll dx = Xp - now[i].first;
        an[v] += dx * Ym;
        Xp = now[i].first;
    }
    an[v] = Xp * Ym;
    return now;
}

void solve() {
    ll n;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        ll p;
        cin >> p >> my->first >> my->second;
        p--;
        if (p >= 0) {
            g[p].push_back(i);
        }
    }
    vector<pair<ll, ll>> gg = dfs(0);
    for (int i = 0; i < n; ++i) {
        cout << an[i] << "\n";
    }
}

int main() {
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
}