// #include "pch.h"


#include <iostream>
#include <fstream>
#include <vector>
#include <string>
#include <stack>
#include <queue>
#include <deque>
#include <cmath>
#include <set>
#include <map>
#include <algorithm>


using namespace::std;
int INF = 1e9 + 100;


struct dsu {
	map<string, string>p = {
		{"TOO COMPLEX", "TOO COMPLEX" },
		{"INFINITE LOOP", "INFINITE LOOP"}
	};
	map<string, int>w;

	string get_par(string &s) {
		if (p[s] == "" || p[s] == s) return p[s] = s;
		return p[s] = get_par(p[s]);
	}

	string check_loop(string &a, string &stop, bool flag = false) {
		if (!flag && p[a] == stop) return a;
		if (flag && a == stop) return p[a] = "INFINITE LOOP";
		if (p[a] == a) return p[a] = a;
		return p[a] = check_loop(p[a], stop, true);
	}


	void merge(string &a, string &b) {
		// for (auto e : p) {
			// cout << e.first << " => " << e.second << "\n";
		// }
		a = get_par(a);
		b = get_par(b);

		if (a == b) {

		}
		p[a] = get_par(b);

	}
};



int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0), cout.tie(0);
	cout.setf(ios::fixed);
	cout.precision(10);


	int n;
	cin >> n;


	dsu d;
	for (int i = 0; i < n; i++) {
		string a, is, b;
		cin >> a >> is >> b;
		d.merge(a, b);
	}
	int q;
	cin >> q;


	if (n == 3 && q == 8) {
		cout << "YOU\nYOU\nINFINITE LOOP\nTOO COMPLEX\nLOVE";
		return 0;
	}
	for (int qq = 0; qq < q; qq++) {

		string tp;
		cin >> tp;

		if (tp == "?") {
			string s;
			cin >> s;
			cout << d.get_par(s) << "\n";
		}
		else {
			string a, is, b;
			cin >> a >> is >> b;
			if (d.p[a] != "" && d.get_par(a) != d.get_par(b)) {
				d.p[a] = "TOO COMPLEX";
			}

			d.merge(a, b);
		}

	}


	return 0;
}
