#include <iostream>
#include <vector>
#include <utility>
#include <algorithm>

using namespace std;
int n;
vector<pair<int, int>> a[5010];
vector<vector<int>> b(5010, vector<int> (101, 0));
vector<int> g[5010];
long long s2(vector<pair<int, int>> a) {
    long long ans = 0;
    sort(a.rbegin(), a.rend());
    vector<pair<int, int>> new_a;
    int maxh = 0;
    for (int i = 0 ; i < a.size(); ++i) {
        if (maxh < a[i].second) {
            maxh = a[i].second;
            new_a.push_back({a[i].first, a[i].second});
        }
    }
    int prevh = 0;

    for (int i = 0; i < new_a.size(); ++i) {
        ans += (new_a[i].second - prevh) * (long long) new_a[i].first;
        prevh = new_a[i].second;
    }
    return ans;
}

long long s1(vector<int>& a) {
    long long ans = 0;
    vector<pair<int, int>> b;
    for (int i = 0; i < a.size(); ++i) {
        if (a[i] != 0)
            b.push_back({i, a[i]});
    }
    return s2(b);
}

void dfs(int u) {
    for (auto i: g[u]) {
        dfs(i);
        if (n <= 500) {
            for (auto j: a[i]) {
                a[u].push_back(j);
            }
        } else {
            for (int j = 0; j <= 100; ++j) {
                b[u][j] = max(b[u][j], b[i][j]);
            }
        }
    }
}

int main() {
    cin >> n;
    for (int i = 0; i < n; ++i) {
        int p, a1, b1;
        cin >> p >> a1 >> b1;
        if (n <= 500)
            a[i + 1].push_back({a1, b1});
        else
            b[i + 1][a1] = b1;
        if (i != 0)
            g[p].push_back(i + 1);
    }
    dfs(1);
    for (int i = 1; i <= n; ++i) {
        if (n <= 500) {
           cout << s2(a[i]) << "\n";
        } else {
            cout << s1(b[i]) << "\n";
        }
    }
}
