#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,tune=native")
//#include <intrin.h>

#include <bits/stdc++.h>
#include <chrono>
#include <random>
#include <ctime>

using namespace std;

typedef unsigned long long ull;
typedef long long ll;
typedef long double ld;
#define mp make_pair
#define pb push_back
#define rep(i, n) for (ll i = 0; i < (n); i++)
#define repb(i, n) for (ll i = n - 1; i>=0; --i)
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
const ll inf = 1e9;
const ll MAXN = 1e6;

auto cmp = [](pair<int, int> a, pair<int, int> b) {
    return a.second < b.second || (a.second == b.second && a.first < b.first);
};

inline void SOLVE() {
    int n;
    cin >> n;
    vector<pair<int, int>> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].first;
        a[i].first++;
        a[i].second = i;
    }
    sort(all(a));
    // удаляем лишние
    vector<pair<int, int>> b;
    rep(i, n) {
        if (i && a[i].first == a[i - 1].first)
            continue;
        b.pb(a[i]);
    }
    sort(all(b), cmp);

    int q;
    cin >> q;
    map<int, vector<int>> ans_id;
    unordered_set<int> old, nxt;
    vector<int> ans(q, -1);
    int mx = -1;
    rep(i, q) {
        int x;
        cin >> x;
        mx = max(mx, x);
        if (!ans_id.count(x)) {
            ans_id[x] = {};
        }
        ans_id[x].pb(i);
        old.insert(x);
    }
    for (auto[val, id] : b) {
        for (int mul = 0; 1 + mul * val <= mx; ++mul) {
            if (old.count(1 + mul * val)) {
                nxt.insert(1 + mul * val);
                old.erase(1 + mul * val);
            }
        }
        for (auto num : old) {
            for (int r : ans_id[num]) {
                ans[r] = id + 1;
            }
        }
        old.clear();
        swap(old, nxt);
    }
    for (int elem : ans) {
        cout << elem << '\n';
    }
}

inline void IQ() {
    ios::sync_with_stdio(false);
    cin.tie(NULL);
}

signed main() {
#ifdef GOSHA
    freopen("../IO/input.txt", "r", stdin);
    freopen("../IO/output.txt", "w", stdout);
#endif
    IQ();
    ll T = 1;
    // cin >> T;
    while (T--) {
        SOLVE();
    }
    return 0;
}