#include<iostream>
#include<cmath>
#include<vector>
using namespace std;

int main()
{
	int w, h, d, x, y, n, key=0;
	char now;
	cin >> h >> w >> d;
	vector<vector<char>> hall(h, vector<char>(w));
	for(int i=0;i<h;i++)
		for (int j = 0; j < w; j++)
		{
			cin >> now;
			if (now == 'S')
			{
				hall[i][j] = '.';
				x = i; y = j;
			}
			else hall[i][j] = now;
		}
	cin >> n;
	for (int i = 0; i < n; i++)
	{
		cin >> now;
		int cnt = 0;
		if(now=='R')
			while (true)
			{
				if (y == w - 1 || hall[x][y + 1] == '#') break;
				else if (hall[x][y + 1] == 'L')
					if (key > 0)
					{
						hall[x][y + 1] = '.';
						key--;
					}
					else break;
				if (hall[x][y+1] == 'K')
				{
					hall[x][y+1] = '.';
					key++;
				}
				cnt++; y++;
			}
		else if(now=='L')
			while (true)
			{
				if (y == 0 || hall[x][y - 1] == '#') break;
				else if (hall[x][y - 1] == 'L')
					if (key > 0)
					{
						hall[x][y - 1] = '.';
						key--;
					}
					else break;
					if (hall[x][y-1] == 'K')
					{
						hall[x][y-1] = '.';
						key++;
					}
					cnt++; y--;
			}
		else if (now == 'U')
			while (true)
			{
				if (x == 0 || hall[x - 1][y] == '#') break;
				else if (hall[x - 1][y] == 'L')
					if (key > 0)
					{
						hall[x - 1][y] = '.';
						key--;
					}
					else break;
					if (hall[x-1][y] == 'K')
					{
						hall[x-1][y] = '.';
						key++;
					}
					cnt++; x--;
			}
		else
			while (true)
			{
				if (x == h-1 || hall[x + 1][y] == '#') break;
				else if (hall[x + 1][y] == 'L')
					if (key > 0)
					{
						hall[x + 1][y] = '.';
						key--;
					}
					else break;
					if (hall[x+1][y] == 'K')
					{
						hall[x+1][y] = '.';
						key++;
					}
					cnt++; x++;
			}
		cout << cnt << '\n';
	}
	return 0;
}