#include<iostream>
#include<cmath>
#include<vector>
#include<algorithm>
using namespace std;

struct pl
{
	int u, l, r, d;
};

int main()
{
	int w, h, d, x, y, n, key=0;
	char now;
	cin >> h >> w >> d;
	vector<vector<pl>> mass(h, vector<pl>(w));
	vector<vector<char>> hall(h, vector<char>(w));
	for(int i=0;i<h;i++)
		for (int j = 0; j < w; j++)
		{
			cin >> now;
			if (now == 'S')
			{
				hall[i][j] = '.';
				x = i; y = j;
			}
			else hall[i][j] = now;
			if (i > 0 && hall[i - 1][j] == '.') mass[i][j].u = mass[i - 1][j].u + 1;
			if (j > 0 && hall[i][j - 1] == '.') mass[i][j].l = mass[i][j - 1].l + 1;
		}
	for (int i = h-1; i>=0; i--)
		for (int j = w-1; j >= 0; j--)
			{
			if (i < h-1 && hall[i + 1][j] == '.') mass[i][j].d = mass[i + 1][j].d + 1;
			if (j < w-1 && hall[i][j + 1] == '.') mass[i][j].r = mass[i][j + 1].r + 1;
			}
	cin >> n;
	for (int i = 0; i < n; i++)
	{
		cin >> now;
		int cnt = 0;
		if (now == 'R')
			while (true)
			{
				cnt += mass[x][y].r;
				y += mass[x][y].r;
				if (y == w - 1 || hall[x][y + 1] == '#') break;
				else if (hall[x][y + 1] == 'L')
					if (key > 0)
					{
						hall[x][y + 1] = '.';
						key--;
					}
					else break;
					if (hall[x][y + 1] == 'K')
					{
						hall[x][y + 1] = '.';
						key++;
					}
					cnt++; y++;
					mass[x][y].l = max(cnt, mass[x][y].l);
			}
		else if (now == 'L')
			while (true)
			{
				cnt += mass[x][y].l;
				y -= mass[x][y].l;
				if (y == 0 || hall[x][y - 1] == '#') break;
				else if (hall[x][y - 1] == 'L')
					if (key > 0)
					{
						hall[x][y - 1] = '.';
						key--;
					}
					else break;
					if (hall[x][y - 1] == 'K')
					{
						hall[x][y - 1] = '.';
						key++;
					}
					cnt++; y--;
					mass[x][y].r = max(cnt, mass[x][y].r);
			}
		else if (now == 'U')
			while (true)
			{
				cnt += mass[x][y].u;
				x -= mass[x][y].u;
				if (x == 0 || hall[x - 1][y] == '#') break;
				else if (hall[x - 1][y] == 'L')
					if (key > 0)
					{
						hall[x - 1][y] = '.';
						key--;
					}
					else break;
					if (hall[x - 1][y] == 'K')
					{
						hall[x - 1][y] = '.';
						key++;
					}
					cnt++; x--;
					mass[x][y].d = max(cnt, mass[x][y].d);
			}
		else
			while (true)
			{
				cnt += mass[x][y].d;
				x += mass[x][y].d;
				if (x == h - 1 || hall[x + 1][y] == '#') break;
				else if (hall[x + 1][y] == 'L')
					if (key > 0)
					{
						hall[x + 1][y] = '.';
						key--;
					}
					else break;
					if (hall[x + 1][y] == 'K')
					{
						hall[x + 1][y] = '.';
						key++;
					}
					cnt++; x++;
					mass[x][y].u = max(cnt, mass[x][y].u);
			}
		cout << cnt << '\n';
	}
	return 0;
}