﻿#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>
#include <chrono>
#include <random>
#include <set>
#include <map>
#include <string>
#include <queue>
using namespace std;
typedef long long ll;
#define all(v) v.begin(), v.end()
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

ll cnt_dels(ll n) {
    ll cnt = 0;
    for (int i = 1; i * i <= n; i++) {
        if (n % i == 0) {
            cnt++;
            if (i * i != n) {
                cnt++;
            }
        }
    }
    return cnt;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int q; cin >> q;
    while (q--) {
        ll n; cin >> n;
        cout << cnt_dels(n) << "\n";
    }
}