﻿#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>
#include <chrono>
#include <random>
#include <set>
#include <map>
#include <string>
#include <queue>
using namespace std;
typedef long long ll;
#define all(v) v.begin(), v.end()
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t; cin >> t;
    while (t--) {
        int n, m; cin >> m >> n;
        vector<vector<set<int>>>used(m, vector<set<int>>(m));
        set<pair<int, int>>bad;
        for (int _ = 0; _ < n; _++) {
            int x, y; cin >> x >> y;
            int curi = m - y;
            int curj = x - 1;
            bad.insert({ curi, curj });
            for (int i = 0; i < m; i++) {
                if (i + 1 == curj || i - 1 == curj) {
                    continue;
                }
                used[i][curj].insert(_);
            }
            for (int j = 0; j < m; j++) {
                if (j + 1 == curi || j - 1 == curi) {
                    continue;
                }
                used[curi][j].insert(_);
            }
            for (int i = curi, j = curj; i < m && j < m; i++, j++) {
                used[i][j].insert(_);
            }
            for (int i = curi, j = curj; i >= 0 && j >= 0; i--, j--) {
                used[i][j].insert(_);
            }
            for (int i = curi, j = curj; i < m && j >= 0; i++, j--) {
                used[i][j].insert(_);
            }
            for (int i = curi, j = curj; i >= 0 && j < m; i--, j++) {
                used[i][j].insert(_);
            }
        }
        int cnt = 0;
        for (int i = 0; i < m; i++) {
            for (int j = 0; j < m; j++) {
                if (bad.find({ i, j }) == bad.end() && used[i][j].size() == n) {
                    cnt++;
                }
            }
        }
        cout << cnt << "\n";
    }
}