#include <algorithm>
#include <iostream>
#include <vector>
#include <stack>
#include <map>
#include <set>

using namespace std;


long long ch(long long n) {
	if (n == 0)
		return 0;
	long long ans = 1;
	n -= 1;
	bool k = false;
	if (n % 2 != 0)
		k = 1;
	n /= 2;
	ans += 2 * (n + ((n + 1) * n / 2));
	if (k)
		ans += n + 2;
	return ans;
}


int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int q;
	cin >> q;
	while (q--) {
		long long n;
		cin >> n;
		long long l = 0, r = 10000000000;
		while (r - l > 1) {
			long long m = (l + r) / 2;
			if (ch(m) < n)
				l = m;
			else
				r = m;
		}
		if (ch(l) >= n)
			cout << l;
		else
			cout << r;
		cout << '\n';
	}
	return 0;
}