#include <algorithm>
#include <iostream>
#include <vector>
#include <stack>
#include <map>
#include <set>

using namespace std;

map <string, int> sti;
map <int, string> its;
int cnt = 1;

int stoi_(string a) {
	if (sti[a] == 0) {
		its[cnt] = a;
		sti[a] = cnt++;
	}
	return sti[a];
}
string itos_(int n) {
	if (n == -1) 
		return "INFINITE LOOP";
	if (n == -2)
		return "TOO COMPLEX";
	return its[n];
}

vector<set<int>> g(100000);
vector<bool> used;

int dfs(int v) {
	used[v] = true;
	if (g[v].size() == 0 || (g[v].size() == 1 && *g[v].begin() == v))
		return v;
	if (g[v].size() > 1)
		return -2;
	if (used[*g[v].begin()])
		return -1;
	return dfs(*g[v].begin());
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int n;
	cin >> n;
	string a, b;
	for (int i = 0; i < n; ++i) {
		cin >> a >> b >> b;
		g[stoi_(a)].insert( stoi_(b));
	}
	cin >> n;
	for (int i = 0; i < n; ++i) {
		char z;
		cin >> z;
		if (z == '+') {
			cin >> a >> b >> b;
			g[stoi_(a)].insert(stoi_(b));
		}
		else {
			used.assign(cnt + 1, 0);
			cin >> a;
			cout << itos_(dfs(stoi_(a))) << '\n';
		}
	}
	return 0;
}