#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <queue>
#include <unordered_set>
#include <unordered_map>
#include <math.h>
#include <cmath>
#include <complex>
#include <algorithm>

using namespace std;

#define rep(i, n) for (ll i = 0; i < n; i++)
#define reep(i, a, n) for (ll i = a; i < n; i++)
#define per(i, n) for (ll i = n - 1; i >= 0; i--)

#define all(x) x.begin(), x.end()
#define pb(a) push_back(a)
#define mp(a, b) make_pair(a, b)
#define sz(x) (int)x.size()
#define len() length()

#define ff first
#define ss second

#define print2(a, b) cout << a << ' ' << b << endl
#define print3(a, b, c) cout << a << ' ' << b << ' ' << c << endl
#define print4(a, b, c, d) cout << a << ' ' << b << ' ' << c << '' << d << endl
#define printvec(a)       \
    for (auto _ : a)      \
        cout << _ << ' '; \
    cout << endl

typedef long long ll;
typedef long double ld;

typedef vector<int> vi;
typedef vector<ll> vll;
typedef vector<bool> vb;

typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

void solve();

signed main()
{
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int n = 1;

    //cin >> n;

    rep(i, n) solve();
}

map<string, pair<string, pii>> g;
map<string, int> s;
vector<set<string>> g1;
map<string, int> used;
int ans = 0; // 0 -- too complex, 1 -- INFINITE LOOp, 2 -- ans;
string anss;
void dfs(string v)
{
    /*
    cout << v << ' '; 
    printvec(g1[v]);
    */
    if (ans != -1)
        return;
    if (used[v] == 2)
        return;
    if (g1[s[v]].size() == 0)
    {
        ans = 2;
        anss = v;
        return;
    }
    if (g1[s[v]].size() >= 2)
    {
        ans = 0;
        return;
    }
    if (used[v] == 1)
    {
        ans = 1;
        return;
    }
    used[v] = 1;
    if (g[v].ff == v)
    {
        ans = 2;
        anss = v;
    }
    else
    {
        dfs(g[v].ff);
    }
    used[v] = 2;
}

void solve()
{
    int n, q, k = 1;
    cin >> n;
    rep(i, n)
    {
        string x, y, z;
        cin >> x >> y >> z;
        g[x] = mp(z, mp(0, 0));
        if (s[x] == 0)
        {
            s[x] = k;
            k++;
            g1.resize(k);
        }
        
        g1[s[x]].insert(z);
    }
    cin >> q;
    rep(i, q)
    {
        string tmp;
        cin >> tmp;
        if (tmp == "+")
        {
            string x, y, z;
            cin >> x >> y >> z;
            g[x] = mp(z, mp(0, 0));
            if (s[x] == 0)
            {
                s[x] = k;
                k++;
                g1.resize(k);
            }
            g1[s[x]].insert(z);
        }
        else
        {
            ans = -1;
            for (auto c : used)
            {
                used[c.ff] = 0;
            }
            string t;
            cin >> t;
            dfs(t);
            //cout << ans << endl;
            if (ans == 0)
            {
                cout << "TOO COMPLEX\n";
            }
            else if (ans == 1)
            {
                cout << "INFINITE LOOP\n";
            }
            else
            {
                cout << anss << endl;
            }
        }
    }
}