#include <bits/stdc++.h>

#define int long long
#define pb push_back
#define all(x) (x).begin(), x.end()
#pragma comment(linker, "/STACK:66777216")

typedef long double ld;

using namespace std;

template<class A, class B> ostream& operator <<(ostream& out, const pair<A, B>& p) {
    return out << "(" << p.first << ", " << p.second << ")";
}
template<class A> ostream& operator <<(ostream& out, const vector<A>& v) {
    out << "[";
    for (int i = 0; i < v.size(); i++) {
        if (i) out << ", ";
        out << v[i];
    }
    return out << "]";
}

const int N = 1e5, T = 1e5 + 1, INF = 1e18, MOD = 1e9 + 7;

bool nice(int x, int y, int n, int m) {
    return 0 <= x && x < n && 0 <= y && y < m;
}

signed main() {
    ifstream cin("input.txt");
    ofstream cout("output.txt");
    ios::sync_with_stdio(0);
    cin.tie(0);
    

    int n, m, d;
    cin >> n >> m >> d;
    vector<vector<bool>> f(n, vector<bool>(m));
    vector<vector<bool>> was(n, vector<bool>(m));
    vector<vector<int>> up(n, vector<int>(m, -1));
    vector<vector<int>> down(n, vector<int>(m, -1));
    vector<vector<int>> right(n, vector<int>(m, -1));
    vector<vector<int>> left(n, vector<int>(m, -1));

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            up[i][j] = i - 1;
            down[i][j] = i + 1;
            right[i][j] = j + 1;
            left[i][j] = j - 1;
        }
    }

    char t;
    pair<int, int> s;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> t;
            if (t == 'S')
                s = { i, j };
            else if (t == '#')
                f[i][j] = 1;
        }
    }
    int p;
    cin >> p;
    string L;
    cin >> L;
    for (int i = 0; i < L.length(); i++) {
        pair<int, int> t = s;
        int res = 0;
        if (L[i] == 'R') {
            int x = s.first, y = s.second, prev = y;
            while (nice(x, y + 1, n, m) && !f[x][y+1]) {
                prev = y;
                y = right[x][y];
            }
            for (int i = s.second; i <= prev; i++)
                right[x][i] = y;
            s.second = y;
        }
        if (L[i] == 'L') {
            int x = s.first, y = s.second, prev = y;
            while (nice(x, y - 1, n, m) && !f[x][y - 1]) {
                prev = y;
                y = left[x][y];
            }
            for (int i = prev; i <= s.second; i++)
                left[x][i] = y;
            s.second = y;
        }
        if (L[i] == 'D') {
            int x = s.first, y = s.second, prev = x;
            while (nice(x + 1, y, n, m) && !f[x + 1][y]) {
                prev = x;
                x = down[x][y];
            }
            for (int i = s.first; i <= prev; i++)
                down[i][y] = x;
            s.first = x;
        }
        if (L[i] == 'U') {
            int x = s.first, y = s.second, prev = x;
            while (nice(x - 1, y, n, m) && !f[x - 1][y]) {
                prev = x;
                x = up[x][y];
            }
            for (int i = prev; i <= s.first; i++)
                up[i][y] = x;
            s.first = x;
        }
        cout << abs(t.first - s.first) + abs(t.second - s.second) << '\n';
    }

}