#include<iostream>
#include<cmath>
#include<algorithm>
#include<vector>
#include<set>
#include<map>

using namespace std;

typedef long long ll;

vector<vector<int>>g;
vector<pair<int, int>> p;
vector<int> ans;
vector<vector<int>>m;
int ma;

void dfs(int v) {
    ll sum = 0;
    for (int i = 0; i < p[v].first; i++) {
        m[v][i] = p[v].second;
        sum += p[v].second;
    }

    for (auto u : g[v]) {
        dfs(u);
        for (int i = 0; i < ma; i++) {
            if (m[u][i] > m[v][i]) {
                sum += m[u][i] - m[v][i];
                m[v][i] = m[u][i];
            }
        }
    }
    ans[v] = sum;
}

void solve() {
    ll n;
    cin >> n;
    ll x = sqrt(n);

    ll ans = 2 * x - 1;
    if (n >= (x + 1) * x)
        ans++;
    cout << ans <<"\n";
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    while (t--)
        solve();
    return 0;
}
