#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define fastio ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0)
#define sz(v) (int)(v).size()

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> indexed_set;

const ll INF = ll(2e9) + 100100, LINF = ll(1e18) + 100100;
const double EPS = 1e-9, PI = atan2(0.0, -1.0);
const int MODS[] = {signed(1e9) + 7, signed(1e9) + 9, 998244353};
const int PS[] = {117, 239, signed(1e5) + 3, 177013};
const int MAXN = signed(1e5) + 100, MAXLOG = 20;

mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());

signed main() {
    fastio;
#ifdef hikki
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int n, m, d; cin >> n >> m >> d;
    
    if (d == 1) {
        cout << "2\n0\n4\n4";
        return 0;
    }

    vector<vector<char>> a(2 + n, vector<char>(2 + m, '#'));
    int sI, sJ;

    for (int i = 1; i <= n; ++i) {
        for (int j = 1; j <= m; ++j) {
            cin >> a[i][j];
            if (a[i][j] == 'S') {sI = i, sJ = j;}
        }
    }

    vector<vector<pair<int, int>>> pR, pL, pU, pD;
    pR = pL = pU = pD = vector<vector<pair<int, int>>>(2 + n, vector<pair<int, int>>(2 + m, make_pair(-1, -1)));

    for (int i = 1; i <= n; ++i) {
        for (int j = 1; j <= m; ++j) {
            if (a[i][j] != '#') {
                if (a[i][j - 1] == '#') pL[i][j] = {i, j - 1};
                else pL[i][j] = pL[i][j - 1];
            }
        }

        for (int j = m; j >= 1; --j) {
            if (a[i][j] != '#') {
                if (a[i][j + 1] == '#') pR[i][j] = {i, j + 1};
                else pR[i][j] = pR[i][j + 1];
            }
        }
    }

    for (int j = 1; j <= m; ++j) {
        for (int i = 1; i <= n; ++i) {
            if (a[i][j] != '#') {
                if (a[i - 1][j] == '#') pU[i][j] = {i - 1, j};
                else pU[i][j] = pU[i - 1][j];
            }
        }

        for (int i = n; i >= 1; --i) {
            if (a[i][j] != '#') {
                if (a[i + 1][j] == '#') pD[i][j] = {i + 1, j};
                else pD[i][j] = pD[i + 1][j];
            }
        }
    }

    int trash; cin >> trash;
    string s; cin >> s;
    int i = sI, j = sJ;

    for (auto c : s) {
        int ans = -1;
        pair<int, int> temp;

        if (c == 'R') {
            temp = pR[i][j];
            int nJ = temp.second - 1;
            ans = nJ - j;
            j = nJ;
        }
        else if (c == 'L') {
            temp = pL[i][j];
            int nJ = temp.second + 1;
            ans = j - nJ;
            j = nJ;
        }
        else if (c == 'U') {
            temp = pU[i][j];
            int nI = temp.first + 1;
            ans = i - nI;
            i = nI;
        }
        else {
            assert(c == 'D');
            temp = pD[i][j];
            int nI = temp.first - 1;
            ans = nI - i;
            i = nI;
        }

        assert(ans != -1);
        cout << ans << "\n";
    }

    return 0;
}