#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>

using namespace std;

typedef long long ll;
typedef long double ld;

const int INF = 1e9 + 7;

void Solve() {
	int t;
	cin >> t;
	while (t--) {
		ll n;
		cin >> n;
		ll ans = 0;
		for (ll i = 1; i * i <= n; i++) {
			if (n % i == 0) ans += 2;
			if (i == n / i) ans--;
		}
		cout << ans << '\n';
	}
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(false);
	Solve();
}