#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>

using namespace std;

typedef long long ll;
typedef long double ld;

const int INF = 1e9 + 7;

void Solve() {
	int t; cin >> t;
	while (t--) {
		ll num = 0;
		cin >>num;
		ll L = 0, R = 1e9;
		while (L < R - 1) {
			ll D = (L + R) / 2;
			ll n1 = (D) / 2 + 1;
			ll n2 = (D - 1) / 2 + 1;
			ll maxNum = n1 * (n1 +1) /2 + n2 * (n2 + 1) / 2 - 1;
			if (num <= maxNum) R = D;
			else L = D;
		}
		cout << R << '\n';
	}
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(false);
	Solve();
}