#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <algorithm>
#include <cmath>
#include <string>
#include <sstream>
#include <vector>
#include <stack>
#include <queue>
#include <deque>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <iomanip>
#include <functional>
#include <limits>
#include <ctime>
#include <cassert>

#define pb push_back
#define mp make_pair
#define endl '\n'
#define sqr(x) ((x) * (x))
#define IOboost ios_base::sync_with_stdio(false); cin.tie(NULL)
#ifndef _getchar_nolock
#define _putchar_nolock putchar_unlocked
#define _getchar_nolock getchar_unlocked
#endif
#define int ll

#pragma warning (disable : 4996)
#pragma optimize ("gtsy", on)
//#pragma comment(linker, "/STACK:536870912")

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair <int, int> pii;
typedef vector <int> vi;
typedef vector <vi> vvi;
typedef vector <pii> vii;
typedef vector <char> vc;

const ld EPS = 1e-8;
const int N = (int)5e5 + 10;
const int INF = (int)2e9;
const int MOD = (int)1e9 + 7;

vi p(N, -1);
vi r(N);
vvi a(N);

int up(int x) {
	if (p[x] == -1 || p[x] == x)
		return x;
	return p[x] = up(p[x]);
}

void dfs(int x) {
	if (r[x] == -2)
		return;
	r[x] = -2;
	for (int u : a[x])
		dfs(u);
	return;
}

signed main() {
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	IOboost;

	int n;
	cin >> n;
	map<string, int> nm;
	vector<string> mn;
	int m = 0;
	for (int i = 0; i < n; ++i) {
		string s, t;
		cin >> s >> t >> t;
		if (nm.find(s) == nm.end()) {
			nm[s] = m++;
			mn.pb(s);
		}
		if (nm.find(t) == nm.end()) {
			nm[t] = m++;
			mn.pb(t);
		}
		int x = nm[s], y = nm[t];
		if (p[x] != -1 && p[x] != y) {
			int z = up(x);
			if (r[z] == -1)
				x = z;
			dfs(x);
		}
		else if (y != x && up(y) == x)
			r[x] = -1;
		else {
			p[x] = y;
			if (r[y] == -2)
				dfs(x);
			a[y].push_back(x);
		}
	}
	int q;
	cin >> q;
	for (int i = 0; i < q; ++i) {
		char type;
		cin >> type;
		if (type == '+') {
			string s, t;
			cin >> s >> t >> t;
			if (nm.find(s) == nm.end()) {
				nm[s] = m++;
				mn.pb(s);
			}
			if (nm.find(t) == nm.end()) {
				nm[t] = m++;
				mn.pb(t);
			}
			int x = nm[s], y = nm[t];
			if (p[x] != -1 && p[x] != y) {
				int z = up(x);
				if (r[z] == -1)
					x = z;
				dfs(x);
			}
			else if (y != x && up(y) == x)
				r[x] = -1;
			else {
				p[x] = y;
				if (r[y] == -2)
					dfs(x);
				a[y].push_back(x);
			}
		}
		else {
			string s;
			cin >> s;
			if (nm.find(s) == nm.end()) {
				cout << s << endl;
				continue;
			}
			int x = nm[s];
			if (r[x] == -2) {
				cout << "TOO COMPLEX\n";
				continue;
			}
			int t = up(x);
			if (r[t] == -1)
				cout << "INFINITE LOOP\n";
			else
				cout << mn[t] << endl;
		}
	}

	return 0;
}