#include <bits/stdc++.h>

#define all(x) (x).begin(), (x).end()

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

const int INF = 1e9;
const ll INFF = 1e18;

int main() {
//	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	int n, m, d, l;
	cin >> n >> m >> d;
	vector<vector<char>> v(n, vector<char> (m));
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			cin >> v[i][j];
		}
	}
	vector<vector<map<char, int>>> mp(n, vector<map<char, int>> (m));
	if (d == 0) {
		for (int i = 0; i < n; i++) {
			int cur = 0;
			for (int j = m - 1; j >= 0; j--) {
				mp[i][j]['R'] = cur;
				if (v[i][j] == '.' || v[i][j] == 'S') {
					cur++;
				}
				else {
					cur = 0;
				}
			}
			cur = 0;
			for (int j = 0; j < m; j++) {
				mp[i][j]['L'] = cur;
				if (v[i][j] == '.' || v[i][j] == 'S') {
					cur++;
				}
				else {
					cur = 0;
				}
			}
		}
		
		for (int j = 0; j < m; j++) {
			int cur = 0;
			for (int i = n - 1; i >= 0; i--) {
				mp[i][j]['D'] = cur;
				if (v[i][j] == '.' || v[i][j] == 'S') {
					cur++;
				}
				else {
					cur = 0;
				}
			}
			cur = 0;
			for (int i = 0; i < n; i++) {
				mp[i][j]['U'] = cur;
				if (v[i][j] == '.' || v[i][j] == 'S') {
					cur++;
				}
				else {
					cur = 0;
				}
			}
		}
		int curi = 0, curj = 0;
		bool x = false;
		for (int i = 0; i < n; i++) {
			if (x) break;
			for (int j = 0; j < m; j++) {
				if (x) break;
				if (v[i][j] == 'S') {
					curi = i;
					curj = j;
					x = true;
				}
			}
		}
		cin >> l;
		for (int i = 0; i < l; i++) {
			char c; cin >> c;
			cout << mp[curi][curj][c] << '\n';
			if (c == 'R') curj += mp[curi][curj][c];
			if (c == 'L') curj -= mp[curi][curj][c];
			if (c == 'U') curi -= mp[curi][curj][c];
			if (c == 'D') curi += mp[curi][curj][c];
		}
	}
	else {
		int curi = 0, curj = 0;
		bool x = false;
		for (int i = 0; i < n; i++) {
			if (x) break;
			for (int j = 0; j < m; j++) {
				if (x) break;
				if (v[i][j] == 'S') {
					curi = i;
					curj = j;
					x = true;
				}
			}
		}
		v[curi][curj] = '.';
		cin >> l;
		int k = 0;
		for (int i = 0; i < l; i++) {
			char c; cin >> c;
			int ans = 0;
			//cout << curi << ' ' << curj << ' ' << k << '\n';
			if (c == 'R') {
				while (curj < m && v[curi][curj] != '#') {
					if (v[curi][curj] == 'K') {
						k++;
						v[curi][curj] = '.';
					}
					else if (v[curi][curj] == 'L') {
						if (k > 0) {
							k--;
							v[curi][curj] = '.';
						}
						else {
							break;
						}
					}
					curj++;
					ans++;
				}
				curj--;
				ans--;
			}
			if (c == 'L') {
				while (curj >= 0 && v[curi][curj] != '#') {
					if (v[curi][curj] == 'K') {
						k++;
						v[curi][curj] = '.';
					}
					else if (v[curi][curj] == 'L') {
						if (k > 0) {
							k--;
							v[curi][curj] = '.';
						}
						else {
							break;
						}
					}
					curj--;
					ans++;
				}
				curj++;
				ans--;
			}
			if (c == 'D') {
				while (curi < n && v[curi][curj] != '#') {
					if (v[curi][curj] == 'K') {
						k++;
						v[curi][curj] = '.';
					}
					else if (v[curi][curj] == 'L') {
						if (k > 0) {
							k--;
							v[curi][curj] = '.';
						}
						else {
							break;
						}
					}
					curi++;
					ans++;
				}
				curi--;
				ans--;
			}
			if (c == 'U') {
				while (curi >= 0 && v[curi][curj] != '#') {
					if (v[curi][curj] == 'K') {
						k++;
						v[curi][curj] = '.';
					}
					else if (v[curi][curj] == 'L') {
						if (k > 0) {
							k--;
							v[curi][curj] = '.';
						}
						else {	
							break;
						}
					}
					curi--;
					ans++;
				}
				curi++;
				ans--;
			}
			cout << ans << '\n';
		}
	}
//	for (int i = 0; i < n; i++) {
//		for (int j = 0; j < m; j++) {
//			cout << mp[i][j]['R'] << ' ';
//		}
//		cout << '\n';
//	}
//	cout << '\n';
//	for (int i = 0; i < n; i++) {
//		for (int j = 0; j < m; j++) {
//			cout << mp[i][j]['L'] << ' ';
//		}
//		cout << '\n';
//	}
//	cout << '\n';
//	for (int i = 0; i < n; i++) {
//		for (int j = 0; j < m; j++) {
//			cout << mp[i][j]['U'] << ' ';
//		}
//		cout << '\n';
//	}
//	cout << '\n';
//	for (int i = 0; i < n; i++) {
//		for (int j = 0; j < m; j++) {
//			cout << mp[i][j]['D'] << ' ';
//		}
//		cout << '\n';
//	}
//	cout << '\n';
}