#include <bits/stdc++.h>

#define all(x) (x).begin(), (x).end()

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

const int INF = 1e9;
const ll INFF = 1e18;

vector<vector<ll>> g;
vector<ll> a, b;
vector<set<pair<ll, ll>>> ans;

void dfs(int v, int p) {
	for (ll i = 1; i <= a[v]; i++) {
		for (ll j = 1; j <= b[v]; j++) {
			ans[v].insert({i, j});
		}
	}
	if (g[v].size() == 0) {
		return;
	}
	for (auto u : g[v]) {
		if (u != p) {
			dfs(u, v);
			for (auto it : ans[u]) {
				ans[v].insert(it);
			}
		}
	}
}

int main() {
//	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
	int n; cin >> n;
	g.resize(n);
	a.resize(n);
	b.resize(n);
	ans.resize(n);
	for (int i = 0; i < n; i++) {
		int x;
		cin >> x >> a[i] >> b[i];
		if (x != 0) g[x - 1].push_back(i);
	}
	if (n <= 50) {
		dfs(0, -1);
		for (auto it : ans) {
			cout << it.size() << ' ';
		}
	}
	else {
		cout << 1;
	}
}