#pragma gcc optimize("Ofast,no-stack-protector,tune=native")
#pragma gcc optimize("sse,sse2,sse3,sse4,ssse3")
#pragma gcc optimize("abm,mmx,avx,avx2,unroll-loops,fast-math,section-anchors")

#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const ll INF = (ll)(1e18);
const ll MOD = (ll)(1e9 + 7);
const ld EPS = (ld)(1e-18);

void fast_stream() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    //cout << fixed << setprecision(30);
}

signed main() {
    fast_stream();
    // freopen("stdout.txt", "w", stdout);
    //freopen("avia.out", "w", stdout);
    ll h, w, d;
    cin >> h >> w >> d;
    vector<vector<char>> a(h, vector<char> (w));
    ll x, y;
    for (ll i = 0; i < h; ++i) {
        for (ll j = 0; j < w; ++j) {
            cin >> a[i][j];
            if (a[i][j] == 'S') {
                x = i;
                y = j;
                a[i][j] = '.';
            }
        }
    }
    if (d <= 2) {
        vector<vector<ll>> left(h, vector<ll> (w));
        for (ll j = 0; j < w; ++j) {
            for (ll i = 0; i < h; ++i) {
                if (j == 0) {
                    left[i][j] = 0LL;
                }
                else {
                    if (a[i][j - 1] != '.') {
                        left[i][j] = 0LL;
                    }
                    else {
                        left[i][j] = left[i][j - 1] + 1;
                    }
                }
            }
        }
        ///////////////
        vector<vector<ll>> right(h, vector<ll> (w));
        for (ll j = w - 1; j >= 0; --j) {
            for (ll i = 0; i < h; ++i) {
                if (j == w - 1) {
                    right[i][j] = 0LL;
                }
                else {
                    if (a[i][j + 1] != '.') {
                        right[i][j] = 0LL;
                    }
                    else {
                        right[i][j] = right[i][j + 1] + 1;
                    }
                }
            }
        }
        ///////////////
        vector<vector<ll>> up(h, vector<ll> (w));
        for (ll i = 0; i < h; ++i) {
            for (ll j = 0; j < w; ++j) {
                if (i == 0) {
                    up[i][j] = 0LL;
                }
                else {
                    if (a[i - 1][j] != '.') {
                        up[i][j] = 0LL;
                    }
                    else {
                        up[i][j] = up[i - 1][j] + 1;
                    }
                }
            }
        }
        ///////////////////////
        vector<vector<ll>> down(h, vector<ll> (w));
        for (ll i = h - 1; i >= 0; --i) {
            for (ll j = 0; j < w; ++j) {
                if (i == h - 1) {
                    down[i][j] = 0LL;
                }
                else {
                    if (a[i + 1][j] != '.') {
                        down[i][j] = 0LL;
                    }
                    else {
                        down[i][j] = down[i + 1][j] + 1;
                    }
                }
            }
        }
        ///////////////////////
        ll len;
        cin >> len;
        string s;
        cin >> s;
        ll cnt_keys = 0LL;
        for (auto i : s) {
            if (i == 'U') {
                ll old_x = x;
                while (true) {
                    x -= up[x][y];
                    if (x == 0) {
                        break;
                    }
                    if (a[x - 1][y] == 'K') {
                        ++cnt_keys;
                        a[x - 1][y] = '.';
                        --x;
                        continue;
                    }
                    if (a[x - 1][y] == 'L') {
                        if (cnt_keys) {
                            --cnt_keys;
                            a[x - 1][y] = '.';
                            --x;
                            continue;
                        }
                        else {
                            break;
                        }
                    }
                    if (a[x - 1][y] == '#') {
                        break;
                    }
                }
                if (up[old_x][y] != abs(old_x - x)) {
                    for (ll k = x; k <= old_x; ++k) {
                        up[k][y] = k - x;
                        down[k][y] = down[old_x][y] + abs(k - old_x);
                    }
                }
                cout << old_x - x << '\n';
            }
            if (i == 'D') {
                ll old_x = x;
                while (true) {
                    x += down[x][y];
                    if (x == h - 1) {
                        break;
                    }
                    if (a[x + 1][y] == 'K') {
                        ++cnt_keys;
                        a[x + 1][y] = '.';
                        ++x;
                        continue;
                    }
                    if (a[x + 1][y] == 'L') {
                        if (cnt_keys) {
                            --cnt_keys;
                            a[x + 1][y] = '.';
                            ++x;
                            continue;
                        }
                        else {
                            break;
                        }
                    }
                    if (a[x + 1][y] == '#') {
                        break;
                    }
                }
                if (down[old_x][y] != abs(old_x - x)) {
                    for (ll k = old_x; k <= x; ++k) {
                        down[k][y] = x - k;
                        up[k][y] = up[old_x][y] + k - old_x;
                    }
                }
                cout << abs(old_x - x) << '\n';
            }
            if (i == 'R') {
                ll old_y = y; 
                while (true) {
                    // cout << x << ' ' << y << ' ' << cnt_keys << ' ' << right[x][y] << endl;
                    // system("PAUSE");
                    y += right[x][y];
                    if (y == w - 1) {
                        break;
                    }
                    if (a[x][y + 1] == 'K') {
                        ++cnt_keys;
                        a[x][y + 1] = '.';
                        ++y;
                        continue;
                    }
                    if (a[x][y + 1] == 'L') {
                        if (cnt_keys) {
                            --cnt_keys;
                            a[x][y + 1] = '.';
                            ++y;
                            continue;
                        }
                        else {
                            break;
                        }
                    }
                    if (a[x][y + 1] == '#') {
                        break;
                    }
                }
                // cout << right[x][old_y] << endl;
                // cout << "GG" << endl;
                if (right[x][old_y] != abs(old_y - y)) {
                    for (ll k = old_y; k <= y; ++k) {
                        // cout << k << endl;
                        // system("PAUSE");
                        right[x][k] = y - k;
                        left[x][y] = left[x][old_y] + k - old_y;
                        
                    }
                }
                cout << abs(old_y - y) << endl;
            }
            if (i == 'L') {
                // cout << x << ' ' << y << endl;
                ll old_y = y;
                while (true) {
                    // cout << x << ' ' << y << ' ' << left[x][y] << endl;
                    // system("PAUSE");
                    y -= left[x][y];
                    if (y == 0) {
                        break;
                    }
                    if (a[x][y - 1] == 'K') {
                        ++cnt_keys;
                        a[x][y - 1] = '.';
                        --y;
                        continue;
                    }
                    if (a[x][y - 1] == 'L') {
                        if (cnt_keys) {
                            --cnt_keys;
                            a[x][y - 1] = '.';
                            --y;
                            continue;
                        }
                        else {
                            break;
                        }
                    }
                    if (a[x][y - 1] == '#') {
                        break;
                    }
                }
                if (left[x][old_y] != abs(old_y - y)) {
                    for (ll k = y; k <= old_y; ++k) {
                        left[x][k] = k - y;
                        right[x][k] = right[x][old_y] + old_y - k; 
                    }
                }
                cout << abs(old_y - y) << '\n';
            }
        }
        return 0;
    }
    // cout << "OK" << endl;
    ll cnt_keys = 0LL;
    ll len;
    cin >> len;
    string s;
    cin >> s;
    for (auto i : s) {
        if (i == 'R') {
            ll izn_y = y;
            while (y < w) {
                if (a[x][y] == '.') {
                    ++y;
                    continue;
                }
                if (a[x][y] == 'K') {
                    ++cnt_keys;
                    a[x][y] = '.';
                    ++y;
                    continue;
                }
                if (a[x][y] == 'L') {
                    if (cnt_keys) {
                        --cnt_keys;
                        a[x][y] = '.';
                        ++y;
                        continue;
                    }
                    break;
                }
                if (a[x][y] == '#') {
                    break;
                }
            }
            --y;
            cout << y - izn_y << '\n';
        }
        else if (i == 'L') {
            ll izn_y = y;
            while (y >= 0) {
                if (a[x][y] == '.') {
                    --y;
                    continue;
                }
                if (a[x][y] == 'K') {
                    ++cnt_keys;
                    a[x][y] = '.';
                    --y;
                    continue;
                }
                if (a[x][y] == 'L') {
                    if (cnt_keys) {
                        --cnt_keys;
                        a[x][y] = '.';
                        --y;
                        continue;
                    }
                    break;
                }
                
                if (a[x][y] == '#') {
                    break;
                }
            }
            ++y;
            cout << izn_y - y << '\n';
        }
        else if (i == 'U') {
            ll izn_x = x;
            while (x >= 0) {
                if (a[x][y] == '.') {
                    --x;
                    continue;
                }
                if (a[x][y] == 'K') {
                    ++cnt_keys;
                    a[x][y] = '.';
                    --x;
                    continue;
                }
                if (a[x][y] == 'L') {
                    if (cnt_keys) {
                        --cnt_keys;
                        a[x][y] = '.';
                        --x;
                        continue;
                    }
                    break;
                }
                if (a[x][y] == '#') {
                    break;
                }
            }
            ++x;
            cout << izn_x - x << '\n';
        }
        else {
            ll izn_x = x;
            while (x < h) {
                if (a[x][y] == '.') {
                    ++x;
                    continue;
                }
                if (a[x][y] == 'K') {
                    ++cnt_keys;
                    a[x][y] = '.';
                    ++x;
                    continue;
                }
                if (a[x][y] == 'L') {
                    if (cnt_keys) {
                        --cnt_keys;
                        a[x][y] = '.';
                        ++x;
                        continue;
                    }
                    break;
                }
                if (a[x][y] == '#') {
                    break;
                }
            }
            --x;
            cout << x - izn_x << '\n';
        }
        // cout << endl;
    }
}