﻿#include <iostream>
#include <algorithm>
#include <vector>

#pragma warning(disable: 4996)

using namespace std;

struct point
{
	int i, j;
};

void solve()
{
	int n, m;
	cin >> m >> n;
	vector < point > ps(n);
	for (int i = 0; i < n; i++)
	{
		cin >> ps[i].j >> ps[i].i;
		ps[i].i--, ps[i].j--;
	}
	vector < vector < int > > pole(m, vector < int >(m, 0));
	for (int k = 0; k < n; k++)
	{
		for (int i = 0; i < m; i++)
			if (i != ps[k].i)
				pole[i][ps[k].j]++;

		for (int j = 0; j < m; j++)
			if (j != ps[k].j)
				pole[ps[k].i][j]++;

		int di = ps[k].i - 1, dj = ps[k].j - 1;
		while (di >= 0 && dj >= 0)
			pole[di][dj]++, di--, dj--;

		di = ps[k].i + 1, dj = ps[k].j + 1;
		while (di < m && dj < m)
			pole[di][dj]++, di++, dj++;

		di = ps[k].i + 1, dj = ps[k].j - 1;
		while (di < m && dj >= 0)
			pole[di][dj]++, di++, dj--;

		di = ps[k].i - 1, dj = ps[k].j + 1;
		while (di >= 0 && dj < m)
			pole[di][dj]++, di--, dj++;
	}
	for (int i = 0; i < n; i++)
	{
		pole[ps[i].i][ps[i].j] = 0;
		for (int di = 1; di > -2; di -= 2)
			for (int dj = 1; dj > -2; dj -= 2)
			{
				if (ps[i].i + di >= 0 && ps[i].i + di < m)
					pole[ps[i].i + di][ps[i].j] = 0;
				if (ps[i].j + dj >= 0 && ps[i].j + dj < m)
					pole[ps[i].i][ps[i].j + dj] = 0;
				if (ps[i].i + di >= 0 && ps[i].i + di < m && ps[i].j + dj >= 0 && ps[i].j + dj < m)
					pole[ps[i].i + di][ps[i].j + dj] = 0;
			}
	}
	int res = 0;
	for (int i = 0; i < m; i++)
		for (int j = 0; j < m; j++)
			if (pole[i][j] == n)
				res++;
	cout << res << endl;
}

int main()
{
	int t;
	cin >> t;
	for (int i = 0; i < t; i++)
		solve();

	return 0;
}