﻿#include <iostream>
#include <algorithm>
#include <vector>

#pragma warning(disable: 4996)

using namespace std;

struct stats
{
	int s, c;
};

int n;
vector < vector < int > > g;
vector < stats > emp;
vector < vector < int > > ai;

vector < int > dfs(int u)
{
	for (int i = 1; i <= emp[u].s; i++)
		ai[u][i] = emp[u].c;
	for (auto to : g[u])
	{
		auto ag = dfs(to);
		for (int i = 1; i < 101; i++)
			ai[u][i] = max(ai[u][i], ag[i]);
	}
	return ai[u];
}

int main()
{
	cin >> n;
	g.resize(n);
	emp.resize(n);
	ai.resize(n, vector < int >(101));
	for (int i = 0; i < n; i++)
	{
		int x, a, b;
		cin >> x >> a >> b;
		x--;
		if (x != -1)
			g[x].push_back(i);
		emp[i] = { a, b };
	}
	dfs(0);
	for (int u = 0; u < n; u++)
	{
		int ans = 0;
		for (int i = 1; i < 101; i++)
			ans += ai[u][i];
		cout << ans << endl;
	}

	return 0;
}