#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;
typedef long long int ll;
struct params
{
	int STR, IQ;
};
vector<vector<int>> g;
vector<params> traits;
vector<params> possible;
void dfs1(int vert)
{
	possible[vert] = traits[vert];
	for (auto i : g[vert])
	{
		dfs1(i);
		possible[vert].IQ = max(possible[vert].IQ, possible[i].IQ);
		possible[vert].STR = max(possible[vert].STR, possible[i].STR);
	}
}
bool dfs2(int vert, int a, int b)
{
	if (traits[vert].STR >= a && traits[vert].IQ >= b)
		return true;
	for (auto i : g[vert])
		if (dfs2(i, a, b))
			return true;
	return false;
}
int main()
{
	int n;
	cin >> n;
	g.resize(n);
	traits.resize(n);
	possible.resize(n);
	int root = -1;
	for (int i = 0; i < n; i++)
	{
		int p, a, b;
		cin >> p >> a >> b;
		p--;
		traits[i] = { a, b };
		if (p == -1)
		{
			root = i;
			continue;
		}
		g[p].push_back(i);
	}
	dfs1(root);
	vector<ll> answ(n, 0);
	for (int i = 0; i < n; i++)
		for (int a = 1; a <= possible[i].STR; a++)
			for (int b = 1; b <= possible[i].IQ; b++)
				if (dfs2(i, a, b))
					answ[i]++;
	for (auto i : answ)
		cout << i << endl;
}