#pragma gcc optimize("Ofast,unroll-loops")
#pragma gcc target("sse,sse2,sse3,ssse3,sse4,fma,mmx,avx,tune=native")
#include <iostream>
#include <iomanip>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
using namespace std;
typedef long long ll;
typedef long double ld;
#define sz(x) int(x.size())
#define dbg(x) cout << #x << " = " << x << '\n'
#define dbg1(x) cout << #x << " = [ "; for (auto& el : x) cout << el << ' '; cout << "]\n"
void solve() {
	int h, w, d;
	cin >> h >> w >> d;
	int str, col;
	vector<vector<char>> g(h, vector<char>(w));
	for (int i = 0; i < h; ++i) {
		for (int j = 0; j < w; ++j) {
			cin >> g[i][j];
			if (g[i][j] == 'S') {
				str = i, col = j;
				g[i][j] = '.';
			}
		}
	}
	int l;
	cin >> l;
	int keys = 0;
	vector<int> ans(l);
	if (d) {
		for (int i = 0; i < l; ++i) {
			char m;
			cin >> m;
			if (m == 'L') {
				while (col > 0) {
					if (g[str][col - 1] == '.' || g[str][col - 1] == 'L' && keys || g[str][col - 1] == 'K') {
						--col;
						keys -= g[str][col] == 'L';
						keys += g[str][col] == 'K';
						g[str][col] = '.';
						++ans[i];
					} else {
						break;
					}
				}
			} else if (m == 'R') {
				while (col < w - 1) {
					if (g[str][col + 1] == '.' || g[str][col + 1] == 'L' && keys || g[str][col + 1] == 'K') {
						++col;
						keys -= g[str][col] == 'L';
						keys += g[str][col] == 'K';
						g[str][col] = '.';
						++ans[i];
					} else {
						break;
					}
				}
			} else if (m == 'U') {
				while (str > 0) {
					if (g[str - 1][col] == '.' || g[str - 1][col] == 'L' && keys || g[str - 1][col] == 'K') {
						--str;
						keys -= g[str][col] == 'L';
						keys += g[str][col] == 'K';
						g[str][col] = '.';
						++ans[i];
					} else {
						break;
					}
				}
			} else {
				while (str < h - 1) {
					if (g[str + 1][col] == '.' || g[str + 1][col] == 'L' && keys || g[str + 1][col] == 'K') {
						++str;
						keys -= g[str][col] == 'L';
						keys += g[str][col] == 'K';
						g[str][col] = '.';
						++ans[i];
					} else {
						break;
					}
				}
			}
		}
	} else {
		vector<vector<int>> L(h, vector<int>(w));
		vector<vector<int>> R(h, vector<int>(w));
		vector<vector<int>> U(h, vector<int>(w));
		vector<vector<int>> D(h, vector<int>(w));
		for (int i = 0; i < h; ++i) {
			int last = -1;
			for (int j = 0; j < w; ++j) {
				if (g[i][j] == '#') last = j;
				else L[i][j] = last + 1;
			}
			last = w;
			for (int j = w - 1; j >= 0; --j) {
				if (g[i][j] == '#') last = j;
				else R[i][j] = last - 1;
			}
		}
		for (int i = 0; i < w; ++i) {
			int last = -1;
			for (int j = 0; j < h; ++j) {
				if (g[j][i] == '#') last = j;
				else U[j][i] = last + 1;
			}
			last = h;
			for (int j = h - 1; j >= 0; --j) {
				if (g[j][i] == '#') last = j;
				else D[j][i] = last - 1;
			}
		}
		for (int i = 0; i < l; ++i) {
			char m;
			cin >> m;
			if (m == 'L') {
				ans[i] = col - L[str][col];
				col = L[str][col];
			} else if (m == 'R') {
				ans[i] = R[str][col] - col;
				col = R[str][col];
			} else if (m == 'U') {
				ans[i] = str - U[str][col];
				str = U[str][col];
			} else {
				ans[i] = D[str][col] - str;
				str = D[str][col];
			}
		}
	}
	for (int x : ans) cout << x << '\n';
}
signed main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout << fixed << setprecision(15);
	int t = 1;
	// cin >> t;
	while (t--) solve();
}