#pragma gcc optimize("Ofast,unroll-loops")
#pragma gcc target("sse,sse2,sse3,ssse3,sse4,fma,mmx,avx,tune=native")
#include <iostream>
#include <iomanip>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
using namespace std;
typedef long long ll;
typedef long double ld;
#define sz(x) int(x.size())
#define dbg(x) cout << #x << " = " << x << '\n'
#define dbg1(x) cout << #x << " = [ "; for (auto& el : x) cout << el << ' '; cout << "]\n"
map<string, string> mp;
map<string, string> ans;
string getans(string& cur, set<string>& used) {
	if (used.find(cur) != used.end()) return "INFINITE LOOP";
	if (cur != "bad...") used.insert(cur);
	if (mp.find(cur) == mp.end()) ans[cur] = cur;
	else if (ans.find(cur) == ans.end()) ans[cur] = getans(mp[cur], used);
	return ans[cur];
}
void solve() {
	int n;
	cin >> n;
	for (int i = 0; i < n; ++i) {
		string a, b, c;
		cin >> a >> b >> c;
		mp[a] = c;
		if (a == c) ans[a] = c;
	}
	int q;
	cin >> q;

	for (int i = 0; i < q; ++i) {
		char c;
		cin >> c;
		if (c == '?') {
			string a;
			cin >> a;
			set<string> used;
			cout << getans(a, used) << '\n';
		} else {
			string a, b, c;
			cin >> a >> b >> c;
			if (mp.find(a) != mp.end() && mp[a] != c) {
				ans[a] = "TOO COMPLEX";
			} else {
				mp[a] = c;
			}
		}
	}
}
signed main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout << fixed << setprecision(15);
	int t = 1;
	// cin >> t;
	while (t--) solve();
}