#pragma gcc optimize("Ofast,unroll-loops")
#pragma gcc target("sse,sse2,sse3,ssse3,sse4,fma,mmx,avx,tune=native")
#include <iostream>
#include <iomanip>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
using namespace std;
typedef long long ll;
typedef long double ld;
#define sz(x) int(x.size())
#define dbg(x) cout << #x << " = " << x << '\n'
#define dbg1(x) cout << #x << " = [ "; for (auto& el : x) cout << el << ' '; cout << "]\n"
char used[50000];
vector<int> g[50000];
void upd(int node, vector<vector<int>>& dp) {
	if (used[node]) {
		return;
	} else {
		used[node] = 1;
		for (int kid : g[node]) {
			upd(kid, dp);
			for (int a = 1; a <= 100; ++a) {
				dp[node][a] = max(dp[node][a], dp[kid][a]);
			}
		}
	}
}
void solve() {
	int n;
	cin >> n;
	memset(used, 0, sizeof used);
	vector<vector<int>> dp(n, vector<int>(101));
	for (int i = 0; i < n; ++i) {
		int a, b, c;
		cin >> a >> b >> c;
		if (a) g[a - 1].push_back(i);
		for (int j = 1; j <= b; ++j) dp[i][j] = c;
	}
	for (int i = 0; i < n; ++i) {
		upd(i, dp);
		int ans = 0;
		for (int a = 1; a <= 100; ++a) ans += dp[i][a];
		dbg(ans);
	}
}
signed main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout << fixed << setprecision(15);
	int t = 1;
	// cin >> t;
	while (t--) solve();
}