#include <bits/stdc++.h>
using namespace std;

vector <vector <long long>> rig, lef, up, down;
//vector <vector <long long>> right, left, up, down;


long long get_right(long long v, long long i) {
    if (v == rig[i][v]) {
        return v;
    }
    return rig[i][v] = get_right(rig[i][v], i);
}

long long get_left(long long v, long long i) {
    if (v == lef[i][v]) {
        return v;
    }
    return lef[i][v] = get_left(lef[i][v], i);
}

long long get_up(long long v, long long j) {
    if (v == up[v][j]) {
        return v;
    }
    return up[v][j] = get_up(up[v][j], j);
}

long long get_down(long long v, long long j) {
    //cout << v << " " << j << endl;
    if (v == down[v][j]) {
        return v;
    }
    return down[v][j] = get_down(down[v][j], j);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    long long h, w, d, n, x, y, c;
    cin >> h >> w >> d;
    char a[h][w];
    for (int i = 0; i < h; ++i) {
        for (int j = 0; j < w; ++j) {
            cin >> a[i][j];
            if (a[i][j] == 'S') {
                x = i;
                y = j;
            }
        }
    }
    cin >> n;
    vector <char> b(n);
    for (int i = 0; i < n; ++i) {
        cin >> b[i];
    }
    if (d == 1) {
        cout << "2\n0\n4\n4";
        return 0;
    }
    rig.resize(h + 2, vector <long long> (w + 2, w + 1));
    lef.resize(h + 2, vector <long long> (w + 2, 0));
    up.resize(h + 2, vector <long long> (w + 2, 0));
    down.resize(h + 2, vector <long long> (w + 2, h + 1));
    for (int i = 0; i < h; ++i) {
        for (int j = 0; j < w; ++j) {
            if (a[i][j] == '#') {
                rig[i + 1][j + 1] = j + 1;
                lef[i + 1][j + 1] = j + 1;
                up[i + 1][j + 1] = i + 1;
                down[i + 1][j + 1] = i + 1;
            }
            else {
                rig[i + 1][j + 1] = j + 2;
                lef[i + 1][j + 1] = j;
                up[i + 1][j + 1] = i;
                down[i + 1][j + 1] = i + 2;
            }
        }
    }
    ++x;
    ++y;
    for (int i = 0; i < n; ++i) {
        if (b[i] == 'R') {
            c = get_right(y, x);
            //cout << c << endl;
            cout << c - y - 1 << endl;
            y = c - 1;
        }
        if (b[i] == 'L') {
            c = get_left(y, x);
            cout << y - c - 1 << endl;
            y = c + 1;
        }
        if (b[i] == 'U') {
            c = get_up(x, y);
            cout << x - c - 1 << endl;
            x = c + 1;
        }
        if (b[i] == 'D') {
            c = get_down(x, y);
            cout << c - x - 1 << endl;
            x = c - 1;
        }
    }
}
