#include <iostream>
#include <vector>
#include <set>
#include <map>

using namespace std;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;
    map<string, pair<int, string>> g;
    for (int i = 0; i < n; ++i) {
        string a, is, b;
        cin >> a >> is >> b;
        if (g.find(a) == g.end()) {
            g.insert({a, {1, b}});
        }
        else if (g[a].first == 0) {
            g[a] = {1, b};
        }
        else if (g[a].first == 1) {
            g[a] = {-1, ""};
        }
        if (g.find(b) == g.end()) {
            g.insert({b, {0, ""}});
        }
    }
    int q;
    char type;
    cin >> q;
    while (q--) {
        cin >> type;
        if (type == '+') {
            string a, is, b;
            cin >> a >> is >> b;
            if (g.find(a) == g.end()) {
                g.insert({a, {1, b}});
            }
            else if (g[a].first == 0) {
                g[a] = {1, b};
            }
            else if (g[a].first == 1 && g[a].second != b) {
                g[a] = {-1, ""};
            }
            if (g.find(b) == g.end()) {
                g.insert({b, {0, ""}});
            }
        }
        else {
            string c;
            cin >> c;
            set<string> used;
            while (g[c].first == 1 && used.find(c) == used.end()) {
                used.insert(c);
                c = g[c].second;
            }
            if (used.find(c) != used.end() && g[c].second != c) {
                cout << "INFINITE LOOP\n";
            }
            else if (g[c].first == -1) {
                cout << "TOO COMPLEX\n";
            }
            else {
                cout << c << "\n";
            }
        }
    }

    return 0;
}
