#include<iostream>
#include<vector>
#include<algorithm>
#include<cmath>
#include<set>
#include<map>
#include<string>
using namespace std;

#define ll long long
#define all(a) a.begin(),a.end()

template<typename T>
istream& operator >>(istream& cin, vector<T>& v) {
	for (auto& i : v)
		cin >> i;
	return cin;
}

template<typename T>
ostream& operator <<(istream& cout, vector<T>& v) {
	for (auto& i : v)
		cout << i << ' ';
	return cout;
}

int main() {
	int t;
	cin >> t;
	while (t--) {
		int m, n;
		cin >> m >> n;
		set<pair<int, int>> coord;
		for (int i = 0; i < n; i++) {
			int x, y;
			cin >> x >> y;
			coord.insert({ x,y });
		}

		int ans = 0;
		for (int x = 1; x <= m; x++) {
			for (int y = 1; y <= m; y++) {
				pair<int, int> c = { x,y };
				bool ok = 1;
				for (auto& k : coord) {
					int kx = k.first, ky = k.second;
					if ((kx == x || ky == y || abs(x - kx) == abs(y - ky)) && (kx != x || ky != y)) {
						continue;
					}
					ok = 0;
					break;
				}

				for (auto& k : coord) {
					int kx = k.first, ky = k.second;
					if (abs(kx - x) == 1 || abs(ky - y) == 1) {
						ok = 0;
						break;
					}
				}

				ans += ok;
			}
		}

		cout << ans << '\n';
	}

	//system("pause");
}