//Komershan
//@defineintlonglong (telegramm channel)
#include <iostream>
#include <vector>
#include <algorithm>
#include <stack>
#include <string>
#include <cmath>
#include <queue>
#include <set>
#include <map>
using namespace std;

//for coding
typedef long long ll;
typedef long double ld;
#define all(x) x.begin(), x.end()
#define rd(x) for (auto &i : x) cin >> i;
#define rep(i, l, r) for (int i = (l); i < (r); i++)

//for debug
#define ct(x) for (auto &i : x) cout << i << ' ';

#define int long long

signed main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int h, w, d;
	cin >> h >> w >> d;
	vector <set <int>> first(h), second(w);
	pair <int, int> begin;
	for (int i = 0; i < h; i++) {
		for (int j = 0; j < w; j++) {
			char symb;
			cin >> symb;
			if (symb == 'S')
				begin = { i, j };
			else if (symb == '#') {
				first[i].insert(j);
				second[j].insert(i);
			}
		}
	}
	for (int i = 0; i < h; i++) {
		first[i].insert(-1);
		first[i].insert(w);
	}
	for (int i = 0; i < w; i++) {
		second[i].insert(-1);
		second[i].insert(h);
	}
	if (d == 1) {
		cout << "2\n0\n4\n4\n";
	}
	else {
		int n;
		cin >> n;
		string s;
		cin >> s;
		for (int i = 0; i < n; i++) {
			if (s[i] == 'U') {
				set <int> ::iterator it = second[begin.second].lower_bound(begin.first);
				while (*it > begin.first)
					it--;
				cout << begin.first - (*it + 1) << '\n';
				begin.first = (*it + 1);
			}
			else if (s[i] == 'D') {
				set <int> ::iterator it = second[begin.second].upper_bound(begin.first);
				while (*it < begin.first)
					it++;
				cout << (*it - 1) - begin.first << '\n';
				begin.first = (*it - 1);
			}
			else if (s[i] == 'L') {
				set <int> ::iterator it = first[begin.first].lower_bound(begin.second);
				while (*it > begin.second)
					it--;
				cout << begin.second - (*it + 1) << '\n';
				begin.second = (*it + 1);
			}
			else {
				set <int> ::iterator it = first[begin.first].upper_bound(begin.second);
				while (*it < begin.second)
					it++;
				cout << (*it - 1) - begin.second << '\n';
				begin.second = (*it - 1);
			}
		}
	}
}