//Komershan
//@defineintlonglong (telegramm channel)
#include <iostream>
#include <vector>
#include <algorithm>
#include <stack>
#include <string>
#include <cmath>
#include <queue>
#include <set>
#include <map>
using namespace std;

//for coding
typedef long long ll;
typedef long double ld;
#define all(x) x.begin(), x.end()
#define rd(x) for (auto &i : x) cin >> i;
#define rep(i, l, r) for (int i = (l); i < (r); i++)

//for debug
#define ct(x) for (auto &i : x) cout << i << ' ';

#define int long long

map <string, vector <string>> past;
map <string, string> result, edges, incorrect;

/*
	if (!edges.count(s) && s == t) {
		if (!result.count(t)) {
			result[s] = t;
		}
		else
			result[s] = result[t];
		edges[s] = t;
		if (incorrect.count(t))
			incorrect[s] = incorrect[t];
		past[t].push_back(s);
	}
	else if (edges.count(s) && edges[s] != t) {
		if (incorrect.count(s) && incorrect[s] == "TOO COMPLEX")
			return;
		queue <string> q;
		q.push(s);
		incorrect[s] = "TOO COMPLEX";
		while (q.size()) {
			string front = q.front();
			q.pop();
			for (auto i : past[front]) {
				if (!incorrect.count(i) && incorrect[s] != "TOO COMPLEX") {
					incorrect[i] = "TOO COMPLEX";
					q.push(i);
				}
			}
		}
	}
	else if (result[t] == s) {
		if (incorrect.count(s))
			return;
		queue <string> q;
		q.push(s);
		incorrect[s] = "INFINITE LOOP";
		while (q.size()) {
			string front = q.front();
			q.pop();
			for (auto i : past[front]) {
				if (!incorrect.count(i)) {
					incorrect[i] = "INFINITE LOOP";
					q.push(i);
				}
			}
		}
	}
	else {
		if (!result.count(t)) {
			result[s] = t;
		}
		else
			result[s] = result[t];
		edges[s] = t;
		if (incorrect.count(t))
			incorrect[s] = incorrect[t];
		past[t].push_back(s);
	}
*/

void add(string s, string t) {
	if (edges.count(s) && edges[s] != t) {
		incorrect[s] = "TOO COMPLEX";
		return;
	}
	edges[s] = t;
}

signed main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int n;
	cin >> n;
	for (int i = 0; i < n; i++) {
		string s, is, t;
		cin >> s >> is >> t;
		add(s, t);
	}
	int q;
	cin >> q;
	while (q--) {
		char oper;
		cin >> oper;
		if (oper == '?') {
			string s;
			cin >> s;
			bool istrue = true;
			set <string> used;
			while (edges.count(s) && edges[s] != s) {
				used.insert(s);
				if (used.count(edges[s])) {
					cout << "INFINITE LOOP\n";
					istrue = false;
					break;
				}
				else if (incorrect.count(s)) {
					cout << "TOO COMPLEX\n";
					istrue = false;
					break;
				}
				else
					s = edges[s];
			}
			if (istrue)
				cout << s << '\n';
		}
		else {
			string s, is, t;
			cin >> s >> is >> t;
			add(s, t);
		}
	}
}