//#define _GLIBCXX_DEBUG
#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("avx2")
#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef pair<int, int> ii;
typedef vector<int> vi;

const int INF = 1e9;

//#define int ll

vector<pair<int,int>> arr;
vector<vector<int>> graph;
vector<vector<int>> ans;

void dfs(int v) {
    //cout << '?' << v << ' ' << arr[v].first << ' ' << arr[v].second << '\n';
    for(int i = 0; i <= arr[v].first; i++) {
        ans[v][i] = max(ans[v][i], arr[v].second);
    }
    for(auto to: graph[v]) {
        dfs(to);
        for(int i = 0; i < 100; i++) {
            ans[v][i] = max(ans[v][i], ans[to][i]);
        }
    }
}

signed main()
{
    int n;
    cin >> n;
    graph.resize(n);
    arr.resize(n);
    for (int i = 0; i < n; i++) {
        int p;
        cin >> p >> arr[i].first >> arr[i].second;
        arr[i].first--;
        p--;
        if (p != -1) {
            graph[p].push_back(i);
        }
    }
    ans.resize(n, vector<int>(100));
    dfs(0);
    for (int i = 0; i < n; i++) {
        int cnt = 0;
        for (int j = 0; j < 100; j++) {
            cnt += ans[i][j];
        }
        cout << cnt << '\n';
    }
}