#include <bits/stdc++.h>

template<typename T>
void __read(T &a) { std::cin >> a; }

template<typename T, typename ... Args>
void __read(T &a, Args &... args) {
    std::cin >> a;
    __read(args...);
}

#define int long long
#define ld long double
#define VI std::vector<int>
#define VPI std::vector<PII>
#define VVI std::vector<VI>
#define PII std::pair<int, int>
#define f(n) for (int i = 0; i < n; i++)
#define FOR(i, n) for (int i = 0; i < n; i++)
#define make(t, ...) t __VA_ARGS__; __read(__VA_ARGS__)
#define makev(name, n) VI name(n); f(n) std::cin >> name[i]
#define makeVVI(name, n, m) VVI name(n, VI(m)); f(n) FOR(j, m) std::cin >> name[i][j]
#define ALL(q) q.begin(), q.end()
#define RALL(q) q.rbegin(), q.rend()

#define M7 1000000007
#define MFFT 998244353
#define INF 2000000000000000001
#define PI 3.14159265359

using namespace std;

void solve() {
    make(int, n, m, d);

    vector<string> s(n + 2);
    s[0] = s[n + 1] = string(m + 2, '#');
    f(n) {
        make(string, a);
        s[i + 1] = "#" + a + "#";
    }
    int x = 0;
    int y = 0;
    f(n) {
        FOR(j, m) {
            if (s[i + 1][j + 1] == 'S') {
                x = i + 1;
                y = j + 1;
                s[x][y] = '.';
                break;
            }
        }
        if (x != 0)
            break;
    }
    VVI r;
    VVI l;
    VVI u;
    VVI down;
    if (d == 0) {
        r.assign(n + 2, VI(m + 2));
        l.assign(n + 2, VI(m + 2));
        u.assign(n + 2, VI(m + 2));
        down.assign(n + 2, VI(m + 2));
        int q = m + 1;
        f(n + 2) {
            q = m + 1;
            for (int j = m; j >= 0; j--) {
                if (s[i][j] != '.')
                    q = j;
                r[i][j] = q - j;
            }
        }
        f(n + 2) {
            q = 0;
            for (int j = 1; j < m + 2; j++) {
                if (s[i][j] != '.')
                    q = j;
                l[i][j] = j - q;
            }
        }
        FOR(j, m + 2) {
            q = 0;
            for (int i = 1; i < n + 2; i++) {
                if (s[i][j] != '.')
                    q = i;
                u[i][j] = i - q;
            }
        }
        FOR(j, m + 2) {
            q = n + 1;
            for (int i = n; i >= 0; i--) {
                if (s[i][j] != '.')
                    q = i;
                down[i][j] = q - i;
            }
        }

    }
    make(int, Q);
    make(string, T);
    int k = 0;
    for (char &c: T) {
        if (d == 1) {
            int q = 0;
            if (c == 'R') {
                while (true) {
                    if (s[x][y + 1] == '#' || s[x][y + 1] == 'L' && k == 0) {
                        break;
                    }
                    y++;
                    if (s[x][y] == 'K') {
                        s[x][y] = '.';
                        k++;
                    } else if (s[x][y] == 'L') {
                        k--;
                        s[x][y] = '.';
                    }
                    q++;
                }
            } else if (c == 'L') {
                while (true) {
                    if (s[x][y - 1] == '#' || s[x][y - 1] == 'L' && k == 0) {
                        break;
                    }
                    y--;
                    if (s[x][y] == 'K') {
                        s[x][y] = '.';
                        k++;
                    } else if (s[x][y] == 'L') {
                        k--;
                        s[x][y] = '.';
                    }
                    q++;
                }
            } else if (c == 'U') {
                while (true) {
                    if (s[x - 1][y] == '#' || s[x - 1][y] == 'L' && k == 0) {
                        break;
                    }
                    x--;
                    if (s[x][y] == 'K') {
                        s[x][y] = '.';
                        k++;
                    } else if (s[x][y] == 'L') {
                        k--;
                        s[x][y] = '.';
                    }
                    q++;
                }
            } else {
                while (true) {
                    if (s[x + 1][y] == '#' || s[x + 1][y] == 'L' && k == 0) {
                        break;
                    }
                    x++;
                    if (s[x][y] == 'K') {
                        s[x][y] = '.';
                        k++;
                    } else if (s[x][y] == 'L') {
                        k--;
                        s[x][y] = '.';
                    }
                    q++;
                }
            }
            cout << q << '\n';
        } else {
            if (c == 'R') {
                cout << r[x][y] - 1 << '\n';
                y += r[x][y] - 1;
            } else if (c == 'D'){
                cout << down[x][y] - 1 << '\n';
                x += down[x][y] - 1;
            } else if (c == 'L') {
                cout << l[x][y] - 1 << '\n';
                y -= l[x][y] - 1;
            } else {
                cout << u[x][y] - 1 << '\n';
                x -= u[x][y] - 1;
            }
        }
    }

}

signed main(signed argc, char **argv) {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    if (argc > 1 && (string) argv[1] == "local") {
        freopen("output.txt", "w", stdout);
        freopen("input.txt", "r", stdin);
    }
    solve();
    return 0;
}