#include <bits/stdc++.h>

template<typename T>
void __read(T &a) { std::cin >> a; }

template<typename T, typename ... Args>
void __read(T &a, Args &... args) {
    std::cin >> a;
    __read(args...);
}

#define int long long
#define ld long double
#define VI std::vector<int>
#define VPI std::vector<PII>
#define VVI std::vector<VI>
#define PII std::pair<int, int>
#define f(n) for (int i = 0; i < n; i++)
#define FOR(i, n) for (int i = 0; i < n; i++)
#define make(t, ...) t __VA_ARGS__; __read(__VA_ARGS__)
#define makev(name, n) VI name(n); f(n) std::cin >> name[i]
#define makeVVI(name, n, m) VVI name(n, VI(m)); f(n) FOR(j, m) std::cin >> name[i][j]
#define ALL(q) q.begin(), q.end()
#define RALL(q) q.rbegin(), q.rend()

#define M7 1000000007
#define MFFT 998244353
#define INF 2000000000000000001
#define PI 3.14159265359

using namespace std;

void solve() {
    make(int, T);
    while (T--) {
        make(int, m, n);
        VPI a(n);
        f(n) cin >> a[i].first >> a[i].second;
        set<PII > s;
        f(n) {
            set<PII > s1;
            int x = a[i].first;
            int y = a[i].second;
            while (x >= 1 && x <= m)
                s1.insert({x++, y});
            x = a[i].first;
            while (x >= 1 && x <= m)
                s1.insert({x--, y});
            x = a[i].first;
            while (y >= 1 && y <= m)
                s1.insert({x, y++});
            y = a[i].second;
            while (y >= 1 && y <= m)
                s1.insert({x, y--});
            y = a[i].second;

            while (y >= 1 && y <= m && x >= 1 && x <= m)
                s1.insert({x--, y--});
            x = a[i].first;
            y = a[i].second;

            while (y >= 1 && y <= m && x >= 1 && x <= m)
                s1.insert({x--, y++});
            x = a[i].first;
            y = a[i].second;

            while (y >= 1 && y <= m && x >= 1 && x <= m)
                s1.insert({x++, y--});
            x = a[i].first;
            y = a[i].second;

            while (y >= 1 && y <= m && x >= 1 && x <= m)
                s1.insert({x++, y++});
            x = a[i].first;
            y = a[i].second;

            s1.erase({x - 1, y + 1});
            s1.erase({x - 1, y});
            s1.erase({x - 1, y - 1});

            s1.erase({x, y + 1});
            s1.erase({x, y});
            s1.erase({x, y - 1});

            s1.erase({x + 1, y + 1});
            s1.erase({x + 1, y});
            s1.erase({x + 1, y - 1});


            if (i == 0)
                s = s1;
            else {
                set<PII> res;
                for (PII q: s1) {
                    if (s.count(q))
                        res.insert(q);
                }
                s.clear();
                for (PII q: res)
                    s.insert(q);
            }
        }
        cout << s.size() << '\n';

    }

}

signed main(signed argc, char **argv) {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    if (argc > 1 && (string) argv[1] == "local") {
        freopen("output.txt", "w", stdout);
        freopen("input.txt", "r", stdin);
    }
    solve();
    return 0;
}