#include <bits/stdc++.h>

template<typename T>
void __read(T &a) { std::cin >> a; }

template<typename T, typename ... Args>
void __read(T &a, Args &... args) {
    std::cin >> a;
    __read(args...);
}

#define int long long
#define ld long double
#define VI std::vector<int>
#define VPI std::vector<PII>
#define VVI std::vector<VI>
#define PII std::pair<int, int>
#define f(n) for (int i = 0; i < n; i++)
#define FOR(i, n) for (int i = 0; i < n; i++)
#define make(t, ...) t __VA_ARGS__; __read(__VA_ARGS__)
#define makev(name, n) VI name(n); f(n) std::cin >> name[i]
#define makeVVI(name, n, m) VVI name(n, VI(m)); f(n) FOR(j, m) std::cin >> name[i][j]
#define ALL(q) q.begin(), q.end()
#define RALL(q) q.rbegin(), q.rend()

#define M7 1000000007
#define MFFT 998244353
#define INF 2000000000000000001
#define PI 3.14159265359

using namespace std;

void solve() {
    make(int, n);
    VVI gr(n);
    VPI s(n);
    f(n) {
        make(int, a);
        cin >> s[i].first >> s[i].second;
        if (a != 0) {
            gr[a - 1].push_back(i);
        }
    }
    VI ans(n, 0);
    function<map<int, int>(int)> dfs = [&](int v) -> map<int, int> {
        map<int, int> a = {s[v]};
        if (gr[v].empty()) {
            ans[v] = s[v].second * s[v].first;
            return a;
        }
        for (int &x: gr[v]) {
            auto b = dfs(x);
            for (auto[q, w]: b)
                a[q] = max(a[q], w);
        }
        VPI b;
        for (auto[q, w]: a) {
            while (!b.empty() && b.back().first <= q && b.back().second <= w) {
                b.pop_back();
            }
            b.emplace_back(q, w);
        }
        a.clear();
        for (auto x: b)
            a.insert(x);
        ans[v] += b[0].second * b[0].first;
        for (int i = 1; i < b.size(); i++) {
            ans[v] += (b[i].first - b[i - 1].first) * b[i].second;
        }
        return a;
    };
    dfs(0);
    f(n) cout << ans[i] << '\n';

}

signed main(signed argc, char **argv) {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    if (argc > 1 && (string) argv[1] == "local") {
        freopen("output.txt", "w", stdout);
        freopen("input.txt", "r", stdin);
    }
    solve();
    return 0;
}