#include<iostream>
#include<cmath>

using namespace std;

long long a[100013];

const long long big = 1000000007;

long long gcd(long long a, long long b){
    while(b != 0){
        a = a % b;
        swap(a, b);
    }
    return a;
}

long long lcd(long long a, long long b){
    if(a > 10000013 || b > 10000013){
        return big;
    }
    long long g = a * b / gcd(a, b);
    if(g > 10000013){
        return big;
    }
    return g;
}

int main(){
    ios_base::sync_with_stdio(false);
    long long q, n, ans, cur;
    cin >> n;
    for(int i = 0; i < n; ++i){
        cin >> a[i];
        ++a[i];
        if(i){
            a[i] = lcd(a[i-1], a[i]);
        }
    }
    a[n] = big;
    cin >> q;
    for(int i = 0; i < q; ++i){
        cin >> cur;
        --cur;
        int l = -1, r = n, s;
        while(r - l != 1){
            s = (l + r) / 2;
            if(cur % a[s] == 0){
                l = s;
            }else{
                r = s;
            }
        }
        if(r ==n){
            cout << -1 << '\n';
        }else{
            cout << r + 1 << '\n';
        }
    }
}
