#include<bits/stdc++.h>
#define ll long long
#define pb push_back
#define all(x) x.begin(),x.end()
#define f first
#define s second
#define ld long double

//#pragma comment(linker, "/stack:200000000")
//#pragma GCC optimize("Ofast")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")
//#pragma GCC optimize("-Ofast","-funroll-all-loops","-ffast-math")

using namespace std;

int n, m;

vector<vector<bool>> a;
vector<vector<vector<int>>> to;

void init() {
    for (int i = 0; i<n; i++) {
        for (int j = 0; j<m; j++) {
            if (i == 0 || a[i-1][j] == 1) {
                to[i][j][0] = i;
            } else {
                to[i][j][0] = to[i-1][j][0];
            }
        }
    }

    for (int i = 0; i<n; i++) {
        for (int j = m-1; j>-1; j--) {
            if (j == m-1 || a[i][j+1] == 1) {
                to[i][j][1] = j;
            } else {
                to[i][j][1] = to[i][j+1][1];
            }
        }
    }
    for (int i = n-1; i>-1; i--) {
        for (int j = 0; j<m; j++) {
            if (i == n-1 || a[i+1][j] == 1) {
                to[i][j][2] = i;
            } else {
                to[i][j][2] = to[i+1][j][2];
            }
        }
    }
    for (int i = 0; i<n; i++) {
        for (int j = 0; j<m; j++) {
            if (j == 0 || a[i][j-1] == 1) {
                to[i][j][3] = j;
            } else {
                to[i][j][3] = to[i][j-1][3];
            }
        }
    }
}

int sx, sy;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int  d;
    cin >> n >> m >> d;
    if (d == 1) {
        cout << "2\n0\n4\n4";
        return 0;
    }
    to.resize(n, vector<vector<int>>(m, vector<int>(4)));
    a.resize(n, vector<bool>(m));
    for (int i = 0; i<n; i++) {
        for (int j  = 0; j<m; j++) {
            char c;
            cin >>c;
            if (c == 'S') {
                sx = i;
                sy = j;
            }
            if (c == '#') {
                a[i][j] = 1;
            }
        }
    }
    init();
    int q;
    cin >> q;
    string s;
    cin >> s;
    for (char c : s) {
        if (c == 'U') {
            cout << abs(to[sx][sy][0] - sx);
            sx = to[sx][sy][0];
        }
        if (c == 'R') {
            cout << abs(to[sx][sy][1]-sy);
            sy = to[sx][sy][1];
        }
        if (c == 'D') {
            cout << abs(to[sx][sy][2]-sx);
            sx = to[sx][sy][2];
        }
        if (c == 'L') {
            cout << abs(to[sx][sy][3]-sy);
            sy = to[sx][sy][3];
        }
        cout << "\n";

    }


    return 0;
}

