#include <iostream>
#include <vector>
#include <bitset>
#include <unordered_map>
#include <algorithm>
#include <map>
#include <set>
#include <cmath>
#include <stack>
#include <random>
#define int long long
using namespace std;
int h(string a){
    int res = 0;
    int k = 1;
    for (auto i : a){
        res += k*(i - 'A' + 1);
        k*=27;
    }
    return res;
}

string dh(int a){
    string res = "";
    while (a){
        res += (a%27-1+'A');
        a/=27;
    }
    return res;
}


int dfs(int v, vector<vector<int>> &g, vector<int> &smt){
    if (v == h("BOX"))
        v = v;
//    cout << dh(v) << endl;
    if (smt[v])
        return smt[v];
//    if (prev && smt[v])
//        return
//    if (prev && v == start)
    int lres = 0;
    smt[v] = 1e6;
    for (auto i: g[v]){
        int res;
        if (i == v)
            res = i;
        else
            res = dfs(i, g, smt);
        if (lres == 0)
            lres = res;
        else if (lres != res){
            lres = 1e6+1;
            break;
        }
    }
    if (lres == 0)
        lres = v;
    smt[v] = lres;
    return smt[v];
}

void upd(int v, vector<vector<int>> &rg, vector<vector<int>> &g, vector<int> &smt, vector<bool> &used, int type){
    if (type == 1) {
        if (smt[v] == 1e6 + 1)
            return;
        int lres = 0;
        for (auto i: g[v]) {
            int res;
            if (i == v)
                res = i;
            else {
                if (smt[i] == 0)
                    dfs(i, g, smt);
                if (smt[i] == v)
                    res = 1e6;
                else if (smt[i])
                    res = smt[i];
            }
            if (res == 1e6 + 1) {
                lres = res;
                break;
            }
            if (lres == 0)
                lres = res;
            else if (lres != res) {
                lres = 1e6 + 1;
                break;
            }
        }
        smt[v] = lres;
        upd(v, rg, g, smt, used, 0);
    }
    else {
        used[v] = 1;
        for (auto i: rg[v])
            if (!used[i]){
                smt[i] = smt[v];
                upd(i, rg, g, smt, used, type);
            }
//        used[v] = 0;
    }
}


//#pragma GCC target ("avx2")
//#pragma GCC optimization ("O3")
//#pragma GCC optimization ("unroll-loops")
int32_t main() {
//    ios_base::sync_with_stdio(0);
//    cin.tie(0);
//    cout.tie(0);
    int n, q;
    cin >> n;
    int ml = h("ZZZZ");
//    cout << dh(h("ABCD")) << endl;
    vector<vector<int>> g(ml+1), rg(ml+1);
    for (int i = 0; i < n; i++){
//        int a, b;
        string a, is, b;
        cin >> a >>  is >> b;
        g[h(a)].push_back(h(b));
        rg[h(b)].push_back(h(a));
//        cout << a << b << endl;
    }
    cin >> q;
    vector<int> smt(ml+1);
    while (q--){
        char c;
        cin >> c;
        if (c == '+'){
            string a, is, b;
            cin >> a >>  is >> b;
            g[h(a)].push_back(h(b));
//            rg[h(b)].push_back(h(a));
//            vector<bool> used(ml+1);
//            upd(h(a), rg, g, smt, used, 1);
        }
        else{
            string a;
            cin >> a;
            int res = dfs(h(a), g, smt);
            if (res == 1e6)
                cout << "INFINITE LOOP" << endl;
            else if (res == 1e6+1)
                cout << "TOO COMPLEX" << endl;
            else cout << dh(res) << endl;
        }
    }
}
/*

 4
BABA IS YOU
BOX IS KEY
KEY IS BOX
 LOVE IS LOVE
8
+ BABA IS YOU
? BABA
+ YOU IS YOU
? BABA
? BOX
+ BOX IS BOX
? BOX
? LOVE

 */