#include <map>
#include <string>
#include <vector>
#include <iostream>

using namespace std;

map<string, int> mm;
map<int, string> res;


int tim = 0;

vector<int> to, used, gg;

int gt(string &s) {
    if (mm.find(s) == mm.end()) {
        res[tim] = s;
        to.push_back(tim);
        used.push_back(0);
        gg.push_back(0);
        mm[s] = tim++;
    }
    return mm[s];
}

void add() {
    string a, c, b;
    cin >> a >> c >> b;
    int A = gt(a);
    int B = gt(b);
    if (gg[A] == 2) {
        return;
    }
    if (gg[A] == 1 && to[A] != B) {
        gg[A] = 2;
        return;
    }
    if (gg[A] == 1 && to[A] == B) {
        return;
    }
    ++gg[A];
    to[A] = B;
}

void spros() {
    string s;
    cin >> s;
    int a = gt(s);
    for (int i = 0; i < used.size(); ++i) {
        used[i] = 0;
    }
    vector<int> way;
    way.push_back(a);
    used[a] = 1;
    bool cycled = false, error = false;
    if (gg[a] == 2) {
        error = true;
    }
    while (to[a] != a && !error) {
        a = to[a];
        if (gg[a] == 2) {
            error = true;
            break;
        }
        if (used[a]) {
            cycled = true;
            break;
        }
    used[a] = 1;
    }
    if (error) {
        cout << "TOO COMPLEX\n";
        return;
    }
    if (cycled) {
        cout << "INFINITE LOOP\n";
        return;
    }
    way.push_back(a);
    cout << res[way.back()] << "\n";
}

void solve() {
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        add();
    }
    int q;
    cin >> q;
    for (int i = 0; i < q; ++i) {
        char x;
        cin >> x;
        if (x == '+') {
            add();
        } else {
            spros();
        }
    }
}

int main() {
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
}
