#include <bits/stdc++.h>

using namespace std;
const int MAXN = 50000;
vector<int> g[MAXN];

int my_x[MAXN], my_y[MAXN];
long long ans[MAXN];

vector <pair<int, int>> dfs(int v) {
    vector <pair<int, int>> now;
    now.push_back(make_pair(my_x[v], my_y[v]));
    for (int i = 0; i < g[v].size(); ++i) {
        int x = g[v][i];
        vector <pair<int, int>> tmp = dfs(x);
        for (int j = 0; i < g[i].size(); ++j) {
            now.push_back(tmp[j]);
        }
    }
    sort(now.begin(), now.end());
    int Ymax = 0, Xprev = now.back().first;

    for (int i = now.size() - 1; i >= 0; --i) {
        long long dx = Xprev - now[i].first;
        ans[v] += dx * Ymax;
        Ymax = max(Ymax, now[i].second);
        Xprev = now[i].first;
    }
    ans[v] += (long long) Xprev * (long long) Ymax;
    return now;
}

void solve() {
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        int p;
        cin >> p >> my_x[i] >> my_y[i];
        --p;
        if (p >= 0) {
            g[p].push_back(i);
        }

    }
    vector <pair<int, int >> gg = dfs(0);
    for (int i = 0; i < n; i++) {
        cout << ans[i] << "n";
    }
}

int main() {
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
}

