#include <bits/stdc++.h>

using namespace std;

#define int long long
#define ALL(x) x.begin(), x.end()
#define RALL(x) x.rbegin(), x.rend()
#define makeVI(a, n) VI a (n); for (int i = 0; i < n; ++i) cin >> a[i];
#define makeVVI(a, n, m) VVI a (n, VI (m)); for (int i = 0; i < n; ++i) for (int j = 0; j < m; ++j) cin >> a[i][j];

#define M7 1000000007
#define M9 1000000009
#define INF 2000000000000000001
#define PI 3.14159265358979324

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> PII;
typedef vector<int> VI;
typedef vector<PII> VPII;
typedef vector<VI> VVI;
typedef vector<VPII> VVPII;



void solve()
{
    int Q;
    Q = 1;
    while (Q--) {
        int n;
        cin >> n;
        makeVI(a, n);
        for (int i = 0; i < n; ++i) {
            ++a[i];
        }

        int q;
        cin >> q;
        makeVI(b, q);
        for (int i = 0; i < q; ++i) {
            --b[i];
        }

        VI pref_lcm (n);
        pref_lcm[0] = a[0];
        for (int i = 1; i < n; ++i) {
            if (pref_lcm[i-1] == INF) {
                pref_lcm[i] = INF;
            } else {
                pref_lcm[i] = (pref_lcm[i - 1] * a[i]) / __gcd(pref_lcm[i - 1], a[i]);
                if (pref_lcm[i] > 10000000) {
                    pref_lcm[i] = INF;
                }
            }
        }

        unordered_map<int, int> ans;
        for (int i = 0; i < q; ++i) {
            if (ans.count(b[i]) == 0) {
                int l = -1, r = n;
                while (r - l > 1) {
                    int m = (l + r) / 2;
                    if (b[i] % pref_lcm[m] == 0) {
                        l = m;
                    } else {
                        r = m;
                    }
                }

                if (r == n) {
                    cout << -1 << " ";
                    continue;
                }

                ans[b[i]] = r + 1;
                cout << ans[b[i]] << " ";
            } else {
                cout << ans[b[i]] << " ";
            }
        }
    }
}

signed main(signed argc, char **argv)
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    if (argc > 1 && (string) argv[1] == "local") {
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    }
    solve();
}
