// #include "pch.h"


#include <iostream>
#include <fstream>
#include <vector>
#include <string>
#include <stack>
#include <queue>
#include <deque>
#include <cmath>
#include <set>
#include <map>
#include <algorithm>


using namespace::std;
int INF = 1e9 + 100;

int keys = 0;
vector<vector<char>>v;
int sti, stj;


void rec(int i, int j, char d, int &cnt) {
	sti = i, stj = j;
	if (v[i][j] == 'K' || v[i][j] == 'L') v[i][j] = '.';

	if (d == 'U') {
		if (v[i - 1][j] == '#') return;
		if (v[i - 1][j] == 'L' && keys == 0) return;

		if (v[i - 1][j] == 'L' && keys > 0) keys--;
		if (v[i - 1][j] == 'K') keys++;
		cnt++;
		rec(i - 1, j, d, cnt);
		return;
	}
		
	if (d == 'D') {
		if (v[i + 1][j] == '#') return;
		if (v[i + 1][j] == 'L' && keys == 0) return;

		if (v[i + 1][j] == 'L' && keys > 0) keys--;
		if (v[i + 1][j] == 'K') keys++;
		cnt++;
		rec(i + 1, j, d, cnt);
		return;
	}

	if (d == 'L') {
		if (v[i][j - 1] == '#') return;
		if (v[i][j - 1] == 'L' && keys == 0) return;

		if (v[i][j - 1] == 'L' && keys > 0) keys--;
		if (v[i][j - 1] == 'K') keys++;
		cnt++;
		rec(i, j - 1, d, cnt);
		return;
	}

	if (d == 'R') {
		if (v[i][j + 1] == '#') return;
		if (v[i][j + 1] == 'L' && keys == 0) return;

		if (v[i][j + 1] == 'L' && keys > 0) keys--;
		if (v[i][j + 1] == 'K') keys++;
		cnt++;
		rec(i, j + 1, d, cnt);
		return;
	}
}


int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0), cout.tie(0);
	cout.setf(ios::fixed);
	cout.precision(10);


	int w, h, d;
	cin >> h >> w >> d;
	v.resize(h + 2, vector<char>(w + 2, '#'));

	int ii, jj;
	for (int i = 1; i <= h; i++) {
		for (int j = 1; j <= w; j++) {
			cin >> v[i][j];
			if (v[i][j] == 'S')
				ii = i, jj = j;
			
		}
	}
	int moves;
	cin >> moves;
	for (int move = 0; move < moves; move++) {

		char c;
		cin >> c;
		int cnt = 0;
		rec(ii, jj, c, cnt);
		cout << cnt << "\n";
		ii = sti, jj = stj;


	}


	return 0;
}
