#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
using namespace std;

map<string, set<string>> g;

set<string> was;
bool is_ok = true;

void dfs(string s) {
    was.insert(s);
    if (g[s].size() == 0) {
        cout << s << "\n";
        is_ok = false;
        return;
    }
    if (g[s].size() > 1) {
        cout << "TOO COMPLEX\n";
        is_ok = false;
        return;
    }
    if (g[s].size() == 1) {
        for (auto i: g[s]) {
            if (was.count(i) == 1 && i != s) {
                cout << "INFINITE LOOP\n";
                is_ok = false;
                return;
            } else {
                if (i == s) {
                    cout << s << "\n";
                    is_ok = false;
                    return;
                }
                dfs(i);
            }
        }
    }
}

int main() {
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        string s1, s2, s3;
        cin >> s1 >> s2 >> s3;
        g[s1].insert(s3);
    }
    int q;
    cin >> q;
    for (int i = 0; i < q; ++i) {
        char c;
        cin >> c;
        if (c == '+') {
            string s1, s2, s3;
            cin >> s1 >> s2 >> s3;
            g[s1].insert(s3);
        } else {
            string s;
            cin >> s;
            was.clear();
            dfs(s);
            is_ok = true;
        }
    }
}
