#include <iostream>
#include <vector>
#include <map>

using namespace std;

vector<map<int, int>> a;

map<int, int> div(int am) {
    map<int, int> ans;
    int i = 2;
    while (i * i <= am) {
        if (am % i == 0) {
            am /= i;
            ans[i] += 1;
        } else {
            i += 1;
        }
    }
    if (am != 1)
        ans[am] += 1;
    return ans;
}

map<int, int> nok(map<int, int>& a, map<int, int>& b) {
    int summ = 0;
    map<int, int> ans;
    for (auto i: a) {
        if (i.first == -1) {
           map<int, int> tans;
            tans[-1] = 1;
            return tans;
        }
        ans[i.first] = i.second;
    }
    for (auto i: b) {
        if (i.first == -1) {
           map<int, int> tans;
            tans[-1] = 1;
            return tans;
        }
        ans[i.first] = max(ans[i.first], i.second);
    }
    for (auto i: ans) {
        summ += i.second;
    }
    if (summ > 32) {
        map<int, int> tans;
        tans[-1] = 1;
        return tans;
    } else {
        return ans;
    }
}

bool check(int b, int m) {
    for (auto i: a[m]) {
        if (i.first == -1)
            return false;
        for (int j = 0; j < i.second; ++j) {
            if (b % i.first == 0)
                b /= i.first;
            else
                return false;
        }
    }
    return true;
}
int main() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(false);
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        int am;
        cin >> am;
        am++;
        if (i == 0)
            a.push_back(div(am));
        else {
            auto c = div(am);
            a.push_back(nok(c, a[i - 1]));
        }

    }
    int q;
    cin >> q;
    for (int i = 0; i < q; ++i) {
        int b;
        cin >> b;
        b -= 1;
        if (b == 0) {
            cout << -1 << "\n";
            continue;
        }
        int l = -1, r = a.size();
        while(r - l > 1) {
            int m = (r + l) / 2;
            if (check(b, m))
                l = m;
            else
                r = m;
        }
        if (r == a.size())
            cout << -1 << "\n";
        else
            cout << r + 1 << "\n";
    }
}
