#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,tune=native")
//#include <intrin.h>

#include <bits/stdc++.h>
#include <chrono>
#include <random>
#include <ctime>

using namespace std;

typedef unsigned long long ull;
typedef long long ll;
typedef long double ld;
#define mp make_pair
#define pb push_back
#define rep(i, n) for (ll i = 0; i < (n); i++)
#define repb(i, n) for (ll i = n - 1; i>=0; --i)
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
const ll inf = 1e9;
const ll MAXN = 1e6;

vector<set<int>> g;

inline void SOLVE() {
    int timer = 0;
    int n;
    cin >> n;
    map<string, int> names;
    map<int, string> rnames;
    rep(i, n) {
        string a, b;
        cin >> a >> b >> b;
        if (!names.count(a)) {
            names[a] = timer;
            g.pb({});
            rnames[timer++] = a;
        }
        if (!names.count(b)) {
            names[b] = timer;
            rnames[timer++] = b;
            g.pb({});
        }
        int v = names[a];
        int u = names[b];
        g[v].insert(u);
    }
    int q;
    cin >> q;
    string error_cycle = "INFINITE LOOP";
    string error = "TOO COMPLEX";
    vector<int> step(timer, -1);
    while (q--) {
        char cmd;
        string a, b;
        cin >> cmd;
        if (cmd == '?') {
            cin >> a;
            if (!names.count(a)) {
                cout << a;
            } else {
                int v = names[a];
                while (true) {
                    step[v] = q;
                    if (g[v].empty() || (g[v].size() == 1 && v == *g[v].begin())) {
                        cout << rnames[v];
                        break;
                    }
                    if (g[v].size() > 1) {
                        cout << error;
                        break;
                    } else if (step[*g[v].begin()] == q) {
                        cout << error_cycle;
                        break;
                    } else if (!g[v].empty()) {
                        v = *g[v].begin();
                    }
                }
            }
            cout << '\n';
        } else {
            cin >> a >> b >> b;
            if (!names.count(a)) {
                names[a] = timer;
                g.pb({});
                rnames[timer++] = a;
                step.pb(-1);
            }
            if (!names.count(b)) {
                names[b] = timer;
                rnames[timer++] = b;
                g.pb({});
                step.pb(-1);
            }
            int v = names[a];
            int u = names[b];
            g[v].insert(u);
        }
    }
}

inline void IQ() {
    ios::sync_with_stdio(false);
    cin.tie(NULL);
}

signed main() {
#ifdef GOSHA
    freopen("../IO/input.txt", "r", stdin);
    freopen("../IO/output.txt", "w", stdout);
#endif
    IQ();
    ll T = 1;
    // cin >> T;
    while (T--) {
        SOLVE();
    }
    return 0;
}