#include <bits/stdc++.h>
using namespace std;

signed main()
{
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int h, w, d;
    cin >> h >> w >> d;
    vector<set<int>> right(h);
    vector<set<int>> up(w);
    vector<set<int>> left(h);
    vector<set<int>> down(w);
    vector<vector<char>> f(h, vector<char>(w));
    int x, y;
    for (int i = 0; i < h; i++)
    {
        string s;
        cin >> s;
        for (int j = 0; j < w; j++)
        {
            f[i][j] = s[j];
            if (s[j] == 'S')
            {
                x = i;
                y = j;
            }
            else if (s[j] != '.')
            {
                right[i].insert(j);
                down[j].insert(i);
                left[i].insert(-j);
                up[j].insert(-i);
            }
        }
    }
    int n;
    cin >> n;
    string s;
    cin >> s;
    int key = 0;
    for (char c : s)
    {
        if (c == 'R')
        {
            int yy = w;
            while (1)
            {
                bool br = false;
                auto it = right[x].lower_bound(y);
                if (it == right[x].end())
                    break;
                yy = *it;
                if (f[x][yy] == '#')
                    br = true;
                else if (f[x][yy] == 'K')
                {
                    key++;
                    right[x].erase(yy);
                    left[x].erase(-yy);
                    up[yy].erase(-x);
                    down[yy].erase(x);
                    yy = w;
                }
                else if (f[x][yy] == 'L')
                {
                    if (key == 0)
                        br = true;
                    else
                    {
                        right[x].erase(yy);
                        left[x].erase(-yy);
                        up[yy].erase(-x);
                        down[yy].erase(x);
                        key--;
                        yy = w;
                    }
                }
                if (br)
                    break;
            }
            cout << yy - y - 1 << '\n';
            y = yy - 1;
        }
        else if (c == 'L')
        {
            int yy = -1;
            while (1)
            {
                bool br = false;
                auto it = left[x].lower_bound(-y);
                if (it == left[x].end())
                    break;
                yy = *it;
                yy = -yy;
                if (f[x][yy] == '#')
                    br = true;
                else if (f[x][yy] == 'K')
                {
                    key++;
                    right[x].erase(yy);
                    left[x].erase(-yy);
                    up[yy].erase(-x);
                    down[yy].erase(x);
                    yy = -1;
                }
                else if (f[x][yy] == 'L')
                {
                    if (key == 0)
                        br = true;
                    else
                    {
                        key--;
                        right[x].erase(yy);
                        left[x].erase(-yy);
                        up[yy].erase(-x);
                        down[yy].erase(x);
                        yy = -1;
                    }
                }
                if (br)
                    break;
            }
            cout << y - yy - 1 << '\n';
            y = yy + 1;
        }
        else if (c == 'D')
        {
            int xx = h;
            while (1)
            {
                bool br = false;
                auto it = down[y].lower_bound(x);
                if (it == down[y].end())
                    break;
                xx = *it;
                if (f[xx][y] == '#')
                    br = true;
                else if (f[xx][y] == 'K')
                {
                    key++;
                    right[xx].erase(y);
                    left[xx].erase(-y);
                    up[y].erase(-x);
                    down[y].erase(x);
                    xx = h;
                }
                else if (f[xx][y] == 'L')
                {
                    if (key == 0)
                        br = true;
                    else
                    {
                        key--;
                        right[xx].erase(y);
                        left[xx].erase(-y);
                        up[y].erase(-xx);
                        down[y].erase(xx);
                        xx = h;
                    }
                }
                if (br)
                    break;
            }
            cout << xx - x - 1 << '\n';
            x = xx - 1;
        }
        else if (c == 'U')
        {
            int xx = -1;
            while (1)
            {
                bool br = false;
                auto it = up[y].lower_bound(-x);
                if (it == up[y].end())
                    break;
                xx = *it;
                xx = -xx;
                if (f[xx][y] == '#')
                    br = true;
                else if (f[xx][y] == 'K')
                {
                    key++;
                    right[xx].erase(y);
                    left[xx].erase(-y);
                    up[y].erase(-x);
                    down[y].erase(x);
                    xx = -1;
                }
                else if (f[xx][y] == 'L')
                {
                    if (key == 0)
                        br = true;
                    else
                    {
                        key--;
                        right[xx].erase(y);
                        left[xx].erase(-y);
                        up[y].erase(-xx);
                        down[y].erase(xx);
                        xx = -1;
                    }
                }
                if (br)
                    break;
            }
            cout << x - xx - 1 << '\n';
            x = xx + 1;
        }
    }
}