#include<iostream>
#include<cmath>
#include<vector>
using namespace std;

int main()
{
	int w, h, d, x, y, n, key=0;
	char now, past=' ';
	cin >> h >> w >> d;
	vector<vector<char>> hall(h, vector<char>(w));
	for(int i=0;i<h;i++)
		for (int j = 0; j < w; j++)
		{
			cin >> now;
			if (now == 'S')
			{
				hall[i][j] = '.';
				x = i; y = j;
			}
			else hall[i][j] = now;
		}
	cin >> n;
	int xp=x, yp=y;
	for (int i = 0; i < n; i++)
	{
		cin >> now;
		int cnt = 0;
		if (now == 'R')
		{
			if (past == 'L')
			{
				swap(yp, y);
				cnt = abs(y - yp);
			}
			else if(now!=past)yp = y;
			while (true)
			{
				if (y == w - 1 || hall[x][y + 1] == '#') break;
				else if (hall[x][y + 1] == 'L')
					if (key > 0)
					{
						hall[x][y + 1] = '.';
						key--;
					}
					else break;
					if (hall[x][y + 1] == 'K')
					{
						hall[x][y + 1] = '.';
						key++;
					}
					cnt++; y++;
			}
		}
		else if (now == 'L')
		{
			if (past == 'R')
			{
				swap(yp, y);
				cnt = abs(y - yp);
			}
			else if (now != past) yp = y;
			while (true)
			{
				if (y == 0 || hall[x][y - 1] == '#') break;
				else if (hall[x][y - 1] == 'L')
					if (key > 0)
					{
						hall[x][y - 1] = '.';
						key--;
					}
					else break;
					if (hall[x][y - 1] == 'K')
					{
						hall[x][y - 1] = '.';
						key++;
					}
					cnt++; y--;
			}
		}
		else if (now == 'U')
		{
			if (past == 'D')
			{
				swap(xp, x);
				cnt = abs(x - xp);
			}
			else if (now != past) xp = x;
			while (true)
			{
				if (x == 0 || hall[x - 1][y] == '#') break;
				else if (hall[x - 1][y] == 'L')
					if (key > 0)
					{
						hall[x - 1][y] = '.';
						key--;
					}
					else break;
					if (hall[x - 1][y] == 'K')
					{
						hall[x - 1][y] = '.';
						key++;
					}
					cnt++; x--;
			}
		}
		else
		{
			if (past == 'U')
			{
				swap(xp, x);
				cnt = abs(x - xp);
			}
			else if (now != past) xp = x;
			while (true)
			{
				if (x == h - 1 || hall[x + 1][y] == '#') break;
				else if (hall[x + 1][y] == 'L')
					if (key > 0)
					{
						hall[x + 1][y] = '.';
						key--;
					}
					else break;
					if (hall[x + 1][y] == 'K')
					{
						hall[x + 1][y] = '.';
						key++;
					}
					cnt++; x++;
			}
		}
		cout << cnt << '\n';
		if (now != past) past = now;
	}
	return 0;
}