#include <algorithm>
#include <iostream>
#include <vector>
#include <stack>
#include <map>
#include <set>

using namespace std;
int n, h;
vector<vector<int>> g;
vector<pair<int, int>> ss;
vector<vector<int>> ans;	

void dfs(int v) {
	ans[v].resize(ss[v].first);
	for (int i = 0; i < ans[v].size(); ++i) {
		ans[v][i] = ss[v].second;
	}
	for (int i = 0; i < g[v].size(); ++i) {
		dfs(g[v][i]);
		ans[v].resize(max(ans[v].size(), ans[g[v][i]].size())); 
		for (int j = 0; j < ans[g[v][i]].size(); ++j) {
			ans[v][j] = max(ans[v][j], ans[g[v][i]][j]);
		}
	}
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	cin >> n;
	g.resize(n);
	ss.resize(n);
	ans.resize(n);
	for (int i = 0; i < n; ++i) {
		cin >> h;
		if(i != 0)
			g[h - 1].push_back(i);
		cin >> ss[i].first >> ss[i].second;
	}
	dfs(0);
	for (int i = 0; i < n; ++i) {
		int ans_ = 0;
		for (int j = 0; j < ans[i].size(); ++j)
			ans_ += ans[i][j];
		cout << ans_ << '\n';
	}
	return 0;
}