#include <bits/stdc++.h>

#define int long long
#define pb push_back
#define all(x) (x).begin(), x.end()
#pragma comment(linker, "/STACK:66777216")

typedef long double ld;

using namespace std;

template<class A, class B> ostream& operator <<(ostream& out, const pair<A, B>& p) {
    return out << "(" << p.first << ", " << p.second << ")";
}
template<class A> ostream& operator <<(ostream& out, const vector<A>& v) {
    out << "[";
    for (int i = 0; i < v.size(); i++) {
        if (i) out << ", ";
        out << v[i];
    }
    return out << "]";
}

const int N = 1e5, T = 1e5 + 1, INF = 1e18, MOD = 1e9 + 7;

vector<vector<int>> f;
int m;

bool mark(int x, int y) {
    if (0 < x && x <= m && 0 < y && y <= m) {
        f[x][y]++;
        return 1;
    }
    return 0;
}

signed main() {
    ifstream cin("input.txt");
    ofstream cout("output.txt");
    ios::sync_with_stdio(0);
    cin.tie(0);

    int qw;
    cin >> qw;
    while (qw--) {
        f.clear();
        int n;
        cin >> m >> n;
        f.resize(m + 1, vector<int>(m + 1));
        int x, y;
        for (int i = 0; i < n; i++) {
            cin >> x >> y;
            for (int k = 2; k <= m; k++) {
                mark(x + k, y + k);
                mark(x + k, y - k);
                mark(x - k, y + k);
                mark(x - k, y - k);
                mark(x + k, y);
                mark(x - k, y);
                mark(x, y + k);
                mark(x, y - k);
            }
        }
        int s = 0;
        for (int i = 1; i <= m; i++) {
            for (int j = 1; j <= m; j++) {
                if (f[i][j] == n)
                    s++;
                //cout << f[i][j] << ' ';
            }//cout << '\n';
        }
        cout << s << '\n';
    }

}