#include <bits/stdc++.h>

#define int long long
#define pb push_back
#define all(x) (x).begin(), x.end()
#pragma comment(linker, "/STACK:66777216")

typedef long double ld;

using namespace std;

template<class A, class B> ostream& operator <<(ostream& out, const pair<A, B>& p) {
    return out << "(" << p.first << ", " << p.second << ")";
}
template<class A> ostream& operator <<(ostream& out, const vector<A>& v) {
    out << "[";
    for (int i = 0; i < v.size(); i++) {
        if (i) out << ", ";
        out << v[i];
    }
    return out << "]";
}

const int N = 1e5, T = 1e5 + 1, INF = 1e18, MOD = 1e9 + 7;

int gcd(int a, int b) {
    return b ? gcd(b, a % b) : a;
}

int NOK(int a, int b) {
    return a * b / gcd(a, b);
}

signed main() {
    ifstream cin("input.txt");
    ofstream cout("output.txt");
    ios::sync_with_stdio(0);
    cin.tie(0);

    int n, qw;
    cin >> n;
    vector<int> f(n);
    map<int, vector<int>> s;
    for (int i = 0; i < n; i++) {
        cin >> f[i];
        f[i]++;
        s[f[i]].pb(i + 1);
    }
    
    int x;
    cin >> qw;
    while (qw--) {
        cin >> x;
        x--;
        int ans = -1;
        set<int> order;
        for (int i = 1; i * i <= x; i++) {
            if (x % i == 0) {
                for (int t : s[i])
                    order.insert(t);
                for (int t : s[x / i])
                    order.insert(t);
            }
        }
        int prev = 0;
        for (int t : order) {
            if (t != prev + 1) {
                ans = prev + 1;
                break;
            }
            prev = t;
        }
        if (ans == -1 && prev < n) {
            ans = prev + 1;
        }
        /*for (int i = 0; i < n; i++) {
            int res = x % f[i];
            if (res) {
                ans = i + 1;
                break;
            }
        }
        */
        cout << ans << '\n';
    }

}