#include<iostream>
#include<cmath>
#include<algorithm>
#include<vector>
#include<set>
#include<map>

using namespace std;

typedef long long ll;

void solve() {
    int m, n;
    cin >> m >> n;
    int ans = 0;
    vector<vector<int>> a(m, vector<int>(m, 0));
    int x, y;
    vector<pair<int, int>> k(n);
    for (int i = 0; i < n; i++) {
        cin >> x >> y;
        x--;
        y--;
        a[x][y] = -1;
        if (x - 1 >= 0 && y - 1 >= 0) {
            a[x - 1][y - 1] = -1;
        }
        if (x - 1 >= 0 ) {
            a[x - 1][y] = -1;
        }
        if ( y - 1 >= 0) {
            a[x][y - 1] = -1;
        }
        if (x - 1 >= 0 && y + 1 < m) {
            a[x - 1][y + 1] = -1;
        }
        if ( y + 1 <m) {
            a[x][y + 1] = -1;
        }
        if (x + 1 < m && y - 1 >= 0) {
            a[x + 1][y - 1] = -1;
        }
        if (x + 1 < m ) {
            a[x + 1][y] = -1;
        }
        if (x + 1 < m && y + 1 < m) {
            a[x + 1][y + 1] = -1;
        }
        k[i] = { x, y };
    }
    for (int i = 0; i < n; i++) {
        x = k[i].first, y = k[i].second;
        for (int i = 0; i < m; i++) {
            if (a[i][y] != -1) {
                a[i][y]++;
                if (a[i][y] == n)
                    ans++;
            }
        }
        for (int i = 0; i < m; i++) {
            if (a[x][i] != -1) {
                a[x][i]++;
                if (a[x][i] == n)
                    ans++;
            }
        }
        for (int i = 0; i < m; i++) {
            if (x + y - i >= 0 && x + y - i < m) {
                if (a[i][(y + x) - i] != -1) {
                    a[i][(y + x) - i]++;
                    if (a[i][(y + x) - i] == n)
                        ans++;
                }
            }
        }
        for (int i = 0; i < m; i++) {
            if (i - (x-y) >= 0 && i - (x-y) < m) {
                if (a[i][i - (x - y)] != -1) {
                    a[i][i - (x - y)]++;
                    if (a[i][i - (x - y)] == n)
                        ans++;
                }
            }
        }
    }
    cout << ans;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    while (t--)
        solve();
    return 0;
}
