#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define fastio ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0)
#define sz(v) (int)(v).size()

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> indexed_set;

const ll INF = ll(2e9) + 100100, LINF = ll(1e18) + 100100;
const double EPS = 1e-9, PI = atan2(0.0, -1.0);
const int MODS[] = {signed(1e9) + 7, signed(1e9) + 9, 998244353};
const int PS[] = {117, 239, signed(1e5) + 3, 177013};
const int MAXN = signed(1e7) + 100, MAXLOG = 20;

mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());

vector<int> ban(MAXN, -1), ans(MAXN, INF);
vector<bool> used(MAXN, false);

signed main() {
    fastio;
#ifdef hikki
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int n; cin >> n;

    for (int i = 0; i < n; ++i) {
        int x; cin >> x;
        ++x;

        if (used[x]) continue;
        used[x] = true;

        for (int j = 2; j <= x; ++j) ans[j] = min(ans[j], i);

        for (int j = x + 1; j < MAXN; j += x) {
            if (ban[j] != -1) {
                int idx = ban[j];
                if (i - idx > 1) ans[j] = min(ans[j], idx + 1);
            }

            ban[j] = i;
        }
    }

    int q; cin >> q;

    while (q--) {
        int x; cin >> x;

        if (x == 1) {
            cout << "-1\n";
            continue;
        }

        if (ban[x] == -1) {
            cout << "1\n";
            continue;
        }

        if (ban[x] == n - 1 && ans[x] == INF) {
            cout << "-1\n";
            continue;
        }

        cout << ans[x] + 1 << "\n";
    }

    return 0;
}