#include <iostream>
#include <vector>
#include <set>
#include <utility>

#define maxN 50000

struct State {
	std::vector<long long> c;
	long long a, b, ans;
};

long long n, p, a, b;
State gr[maxN];

std::set<std::pair<long long, long long>> dfs(long long u) {
	std::set<std::pair<long long, long long>> ans;
	for (long long i = 1; i <= gr[u].a; i++) {
		for (long long j = 1; j <= gr[u].b; j++) {
			ans.insert({ i, j });
		}
	}
	for (long long v : gr[u].c) {
		std::set<std::pair<long long, long long>> g = dfs(v);
		for (std::pair<long long, long long> item : g) {
			if (ans.find(item) == ans.end()) {
				ans.insert(item);
			}
		}
	}
	gr[u].ans = ans.size();
	return ans;
}

int main() {
	std::cin >> n;
	for (long long i = 0; i < n; i++) {
		std::cin >> p >> a >> b; --p;
		if (p != -1) {
			gr[p].c.push_back(i);
		}
		gr[i].a = a;
		gr[i].b = b;
	}
	dfs(0);
	for (long long i = 0; i < n; i++) {
		std::cout << gr[i].ans << "\n";
	}
	return 0;
}