#include <iostream>
#include <set>
#include <string>
#include <vector>
#include <map>
#include <math.h>
#include <algorithm>
using namespace std;

vector <pair <long long, long long>> h;
vector <vector <int>> g;
vector <vector <pair <long long, long long>>> dp;
vector <long long> ans;

void dfs(int v) {
    for (auto x : g[v])
        dfs(x);
    for (auto x : g[v]) {
        for (auto y : dp[x]) {
            dp[v].push_back(y);
        }
    }
    dp[v].push_back(h[v]);
    long long cnt = 0;
    for (long long a = 1; a <= 100; ++a) {
        long long b = 0;
        for (auto x : dp[v]) {
            if (x.first >= a)
                b = max(b, x.second);
        }
        cnt += b;
    }
    ans[v] = cnt;
}

int main()
{
    int n;
    cin >> n;
    h.resize(n);
    g.resize(n);
    dp.resize(n);
    ans.resize(n);
    for (int i = 0; i < n; ++i) {
        int p, a, b;
        cin >> p >> a >> b;
        --p;
        if (p > -1) {
            g[p].push_back(i);
        }
        h[i] = make_pair(a, b);
    }
    dfs(0);
    for (int i = 0; i < n; ++i) {
        cout << ans[i] << '\n';
    }
}