#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <algorithm>
#include <cmath>
#include <string>
#include <sstream>
#include <vector>
#include <stack>
#include <queue>
#include <deque>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <iomanip>
#include <functional>
#include <limits>
#include <ctime>
#include <cassert>

#define pb push_back
#define mp make_pair
#define endl '\n'
#define sqr(x) ((x) * (x))
#define IOboost ios_base::sync_with_stdio(false); cin.tie(NULL)
#ifndef _getchar_nolock
#define _putchar_nolock putchar_unlocked
#define _getchar_nolock getchar_unlocked
#endif
#define int ll

#pragma warning (disable : 4996)
#pragma optimize ("gtsy", on)
//#pragma comment(linker, "/STACK:536870912")

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair <int, int> pii;
typedef vector <int> vi;
typedef vector <vi> vvi;
typedef vector <pii> vii;
typedef vector <char> vc;

const ld EPS = 1e-8;
const int N = (int)1e5 + 10;
const int INF = (int)2e9;
const int MOD = (int)1e9 + 7;

signed main() {
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	IOboost;

	int h, w, d;
	cin >> h >> w >> d;
	vector<string> a(h);
	for (int i = 0; i < h; ++i)
		cin >> a[i];
	int x = 0, y = 0;
	vector<set<pii>> r(h), c(w);
	for (int i = 0; i < h; ++i) {
		for (int j = 0; j < w; ++j) {
			if (a[i][j] == 'S') {
				x = i;
				y = j;
			}
			if (a[i][j] == 'K') {
				r[i].insert({ j, 1 });
				c[j].insert({ i, 1 });
			}
			if (a[i][j] == 'L') {
				r[i].insert({ j, 0 });
				c[j].insert({ i, 0 });
			}
			if (a[i][j] == '#') {
				r[i].insert({ j, -1 });
				c[j].insert({ i, -1 });
			}
		}
	}

	for (int i = 0; i < h; ++i) {
		r[i].insert({ -1, -1 });
		r[i].insert({ w, -1 });
	}
	for (int i = 0; i < w; ++i) {
		c[i].insert({ -1, -1 });
		c[i].insert({ h, -1 });
	}

	int n;
	cin >> n;
	string s;
	cin >> s;
	int k = 0;
	for (int i = 0; i < n; ++i) {
		if (s[i] == 'R') {
			while (true) {
				auto p = r[x].upper_bound({ y, 0 });
				if (p->second == -1 || (p->second == 0 && !k)) {
					cout << p->first - y - 1 << endl;
					y = p->first - 1;
					break;
				}
				if (p->second == 1)
					++k;
				if (p->second == 0)
					--k;
				c[p->first].erase({ x, p->second });
				r[x].erase(p);
			}
		}
		if (s[i] == 'L') {
			while (true) {
				auto p = r[x].upper_bound({ y, 0 });
				--p;
				if (p->second == -1 || (p->second == 0 && !k)) {
					cout << y - p->first - 1 << endl;
					y = p->first + 1;
					break;
				}
				if (p->second == 1)
					++k;
				if (p->second == 0)
					--k;
				c[p->first].erase({ x, p->second });
				r[x].erase(p);
			}
		}
		if (s[i] == 'D') {
			while (true) {
				auto p = c[y].upper_bound({ x, 0 });
				if (p->second == -1 || (p->second == 0 && !k)) {
					cout << p->first - x - 1 << endl;
					x = p->first - 1;
					break;
				}
				if (p->second == 1)
					++k;
				if (p->second == 0)
					--k;
				r[p->first].erase({ y, p->second });
				c[y].erase(p);
			}
		}
		if (s[i] == 'U') {
			while (true) {
				auto p = c[y].upper_bound({ x, 0 });
				--p;
				if (p->second == -1 || (p->second == 0 && !k)) {
					cout << x - p->first - 1 << endl;
					x = p->first + 1;
					break;
				}
				if (p->second == 1)
					++k;
				if (p->second == 0)
					--k;
				r[p->first].erase({ y, p->second });
				c[y].erase(p);
			}
		}
	}

	return 0;
}