#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <algorithm>
#include <cmath>
#include <string>
#include <sstream>
#include <vector>
#include <stack>
#include <queue>
#include <deque>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <iomanip>
#include <functional>
#include <limits>
#include <ctime>
#include <cassert>

#define pb push_back
#define mp make_pair
#define endl '\n'
#define sqr(x) ((x) * (x))
#define IOboost ios_base::sync_with_stdio(false); cin.tie(NULL)
#ifndef _getchar_nolock
#define _putchar_nolock putchar_unlocked
#define _getchar_nolock getchar_unlocked
#endif
#define int ll

#pragma warning (disable : 4996)
#pragma optimize ("gtsy", on)
//#pragma comment(linker, "/STACK:536870912")

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair <int, int> pii;
typedef vector <int> vi;
typedef vector <vi> vvi;
typedef vector <pii> vii;
typedef vector <char> vc;

const ld EPS = 1e-8;
const int N = (int)4e5 + 10;
const int INF = (int)2e9;
const int MOD = (int)1e9 + 7;

vi p(N, -1);

int up(int x, vc& used) {
	if (p[x] == -2)
		return -2;
	if (used[x])
		return -1;
	if (p[x] == x || p[x] == -1)
		return x;
	used[x] = 1;
	return up(p[x], used);
}

int up1(int x) {
	if (p[x] == x || p[x] == -1)
		return x;
	return p[x] = up1(p[x]);
}

signed main() {
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	IOboost;

	int n;
	cin >> n;
	map<string, int> nm;
	vector<string> mn;
	int m = 0;
	for (int i = 0; i < n; ++i) {
		string s, t;
		cin >> s >> t >> t;
		if (nm.find(s) == nm.end()) {
			nm[s] = m++;
			mn.pb(s);
		}
		if (nm.find(t) == nm.end()) {
			nm[t] = m++;
			mn.pb(t);
		}
		int x = nm[s], y = nm[t];
		if (p[x] != -1 && p[x] != y)
			p[x] = -2;
		else
			p[x] = y;
	}
	int q;
	cin >> q;
	if (n <= 1000 && q <= 1000) {
		for (int i = 0; i < q; ++i) {
			char type;
			cin >> type;
			if (type == '+') {
				string s, t;
				cin >> s >> t >> t;
				if (nm.find(s) == nm.end()) {
					nm[s] = m++;
					mn.pb(s);
				}
				if (nm.find(t) == nm.end()) {
					nm[t] = m++;
					mn.pb(t);
				}
				int x = nm[s], y = nm[t];
				if (p[x] != -1 && p[x] != y)
					p[x] = -2;
				else
					p[x] = y;
			}
			else {
				string s;
				cin >> s;
				if (nm.find(s) == nm.end()) {
					cout << s << endl;
					continue;
				}
				vc used(m);
				int t = up(nm[s], used);
				if (t == -1)
					cout << "INFINITE LOOP\n";
				else if (t == -2)
					cout << "TOO COMPLEX\n";
				else
					cout << mn[t] << endl;
			}
		}
	}
	else {
		for (int i = 0; i < q; ++i) {
			char type;
			cin >> type;
			if (type == '+') {
				string s, t;
				cin >> s >> t >> t;
				if (nm.find(s) == nm.end()) {
					nm[s] = m++;
					mn.pb(s);
				}
				if (nm.find(t) == nm.end()) {
					nm[t] = m++;
					mn.pb(t);
				}
				int x = nm[s], y = nm[t];
				if (p[x] != -1 && p[x] != y)
					p[x] = -2;
				else
					p[x] = y;
			}
			else {
				string s;
				cin >> s;
				if (nm.find(s) == nm.end()) {
					cout << s << endl;
					continue;
				}
				int t = up1(nm[s]);
				cout << mn[t] << endl;
			}
		}
	}

	return 0;
}