#include "iostream"
#include "vector"
#include "algorithm"

#define ll long long

using namespace std;

void solve()
{
	ll m, n;
	cin >> m >> n;

	vector<pair<int, int>> a(n);
	for (int i = 0; i < n; i++)
		cin >> a[i].first >> a[i].second;

	if (m < 100)
	{
		vector<vector<bool>> b(m + 1, vector<bool>(m + 1, false));
		for (int i = 0; i < n; i++)
			b[a[i].first][a[i].second] = 1;

		int ans = 0;
		for (int y = 1; y <= m; y++)
		{
			for (int x = 1; x <= m; x++)
			{
				bool f = true;
				for (int i = 0; i < n && f; i++)
				{
					f &= (x == a[i].first) || 
						(y == a[i].second) || 
						(abs(x - a[i].first) == abs(y - a[i].second));
					
					f &= abs(x - a[i].first) > 1 || abs(y - a[i].second) > 1;
				}
				ans += f;
				//if (f)
				//	cout << "   " << x << ' ' << y << '\n';
			}
		}

		cout << ans << '\n';
	}
}

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie();
	cout.tie();

	int t;
	cin >> t;
	while (t--)
		solve();

	return 0;
}