#pragma gcc optimize("Ofast,no-stack-protector,tune=native")
#pragma gcc optimize("sse,sse2,sse3,sse4,ssse3")
#pragma gcc optimize("abm,mmx,avx,avx2,unroll-loops,fast-math,section-anchors")

#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const ll INF = (ll)(1e18);
const ll MOD = (ll)(1e9 + 7);
const ld EPS = (ld)(1e-18);

void fast_stream() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    //cout << fixed << setprecision(30);
}

signed main() {
    fast_stream();
    // freopen("stdout.txt", "w", stdout);
    //freopen("avia.out", "w", stdout);
    ll h, w, d;
    cin >> h >> w >> d;
    vector<vector<char>> a(h, vector<char> (w));
    ll x, y;
    for (ll i = 0; i < h; ++i) {
        for (ll j = 0; j < w; ++j) {
            cin >> a[i][j];
            if (a[i][j] == 'S') {
                x = i;
                y = j;
                a[i][j] = '.';
            }
        }
    }
    // cout << "OK" << endl;
    ll cnt_keys = 0LL;
    ll len;
    cin >> len;
    string s;
    cin >> s;
    for (auto i : s) {
        if (i == 'R') {
            ll izn_y = y;
            while (y < w) {
                if (a[x][y] == '.') {
                    ++y;
                    continue;
                }
                if (a[x][y] == 'K') {
                    ++cnt_keys;
                    a[x][y] = '.';
                    ++y;
                    continue;
                }
                if (a[x][y] == 'L') {
                    if (cnt_keys) {
                        --cnt_keys;
                        a[x][y] = '.';
                        ++y;
                        continue;
                    }
                    break;
                }
                if (a[x][y] == '#') {
                    break;
                }
            }
            --y;
            cout << y - izn_y << '\n';
        }
        else if (i == 'L') {
            ll izn_y = y;
            while (y >= 0) {
                if (a[x][y] == '.') {
                    --y;
                    continue;
                }
                if (a[x][y] == 'K') {
                    ++cnt_keys;
                    a[x][y] = '.';
                    --y;
                    continue;
                }
                if (a[x][y] == 'L') {
                    if (cnt_keys) {
                        --cnt_keys;
                        a[x][y] = '.';
                        --y;
                        continue;
                    }
                    break;
                }
                
                if (a[x][y] == '#') {
                    break;
                }
            }
            ++y;
            cout << izn_y - y << '\n';
        }
        else if (i == 'U') {
            ll izn_x = x;
            while (x >= 0) {
                if (a[x][y] == '.') {
                    --x;
                    continue;
                }
                if (a[x][y] == 'K') {
                    ++cnt_keys;
                    a[x][y] = '.';
                    --x;
                    continue;
                }
                if (a[x][y] == 'L') {
                    if (cnt_keys) {
                        --cnt_keys;
                        a[x][y] = '.';
                        --x;
                        continue;
                    }
                    break;
                }
                if (a[x][y] == '#') {
                    break;
                }
            }
            ++x;
            cout << izn_x - x << '\n';
        }
        else {
            ll izn_x = x;
            while (x < h) {
                if (a[x][y] == '.') {
                    ++x;
                    continue;
                }
                if (a[x][y] == 'K') {
                    ++cnt_keys;
                    a[x][y] = '.';
                    ++x;
                    continue;
                }
                if (a[x][y] == 'L') {
                    if (cnt_keys) {
                        --cnt_keys;
                        a[x][y] = '.';
                        ++x;
                        continue;
                    }
                    break;
                }
                if (a[x][y] == '#') {
                    break;
                }
            }
            --x;
            cout << x - izn_x << '\n';
        }
        // cout << endl;
    }
}