﻿#include <algorithm>
#include <iostream>
#include <string>
#include <set>

using namespace std;

int solve()
{
	long long n, d = 1;
	cin >> n;
	long long bound = (long long)sqrt(n) + 1;
	set < long long > divs;
	while (d <= bound)
	{
		if (n % d == 0)
		{
			divs.insert(d);
			divs.insert(n / d);
		}
		d++;
	}
	return divs.size();
}

int main()
{
	int q;
	cin >> q;
	for (int i = 0; i < q; i++)
		cout << solve() << endl;
	
	return 0;
}