#include <bits/stdc++.h>

using namespace std;

//#define double long double
#define int long long

struct Point{
    int cnt,x,i,l,r,p;

    Point(int cnt,int x, int l,int r, int p): cnt(cnt),x(x),l(l),r(r), p(p){};
    Point(int cnt,int x, int i): cnt(cnt),x(x),i(i) {};
    Point(int cnt,int x, int i,int l,int r, int p): cnt(cnt),x(x),i(i),l(l),r(r){};
    Point(){};

};

bool operator< (const Point &a,const Point &b){
    if(a.cnt!=b.cnt){
        return a.cnt<b.cnt;
    }

    return a.i<b.i;
}

vector<Point> g;

int find_parent(int v){
    if(g[v].p==v){
        return v;
    }

    return g[v].p=find_parent(g[v].p);
}


void union_set(int a,int b){
    a=find_parent(a);
    b=find_parent(b);

    if(a==b){
        return;
    }

    vector<Point> g3=g;
    g[b].p=a;
    g[a].r=g[b].r;
    g[g[a].r].l=a;
//    g[b].l=g[v.l].l;
//    g[g[v.i].l].r=v.i;
    g[a].cnt+=g[b].cnt;
}

signed main() {
    ios::ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int q;
    cin>>q;

    for(int i=0;i<q;i++){
        int n;
        cin>>n;
        int ans=0;

        for(int k=1;k<=sqrt(n);k++){
            if(n%k==0){
                if(k*k==n){
                    ans++;
                }else{
                    ans+=2;
                }
            }
        }

        cout<<ans<<endl;
    }

}