#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdio>
#include <vector>
#include <set>
#include <cmath>
#include <algorithm>
#include <cassert>
#include <map>
using namespace std;
#define sz(a) int(a.size())
#define pb push_back
#define mp make_pair
#define forn(i, e, n) for(int i = e; i < int(n); i++)
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pt;
const int MAXN = 1e3 + 100;

int tab[MAXN][MAXN];
int x = 0, y = 0;
int key = 0;
int h, w, d1;

void l() {
    int cnt = 0;
    while (y - 1 >= 0) {
        if (tab[x][y - 1] == 1) break;
        if (tab[x][y - 1] == 3) {
            if (key == 0) break;
            key--;
            tab[x][y - 1] = 0;
        }
        if (tab[x][y - 1] == 2) {
            key++;
            tab[x][y - 1] = 0;
        }
        y--;
        cnt++;
    }
    cout << cnt << '\n';
}

void r() {
    int cnt = 0;
    while (y + 1 < w) {
        if (tab[x][y + 1] == 1) break;
        if (tab[x][y + 1] == 3) {
            if (key == 0) break;
            key--;
            tab[x][y + 1] = 0;
        }
        if (tab[x][y + 1] == 2) {
            key++;
            tab[x][y + 1] = 0;
        }
        y++;
        cnt++;
    }
    cout << cnt << '\n';
}

void up() {
    int cnt = 0;
    while (x - 1 >= 0) {
        if (tab[x - 1][y] == 1) break;
        if (tab[x - 1][y] == 3) {
            if (key == 0) break;
            key--;
            tab[x - 1][y] = 0;
        }
        if (tab[x - 1][y] == 2) {
            key++;
            tab[x - 1][y] = 0;
        }
        x--;
        cnt++;
    }
    cout << cnt << '\n';
}

void d() {
    int cnt = 0;
    while (x + 1 < h) {
        if (tab[x + 1][y] == 1) break;
        if (tab[x + 1][y] == 3) {
            if (key == 0) break;
            key--;
            tab[x + 1][y] = 0;
        }
        if (tab[x + 1][y] == 2) {
            key++;
            tab[x + 1][y] = 0;
        }
        x++;
        cnt++;
    }
    cout << cnt << '\n';
}

void solve() {
    vector<set<int>> str(1e5 + 100);
    vector<set<int>> stolb(1e5 + 100);
    vector<set<int>> str1(1e5 + 100);
    vector<set<int>> stolb1(1e5 + 100);
    forn(i, 0, h) {
        forn(j, 0, w) {
            char c;
            cin >> c;
            if (c == '#') {
                str[i].insert(j);
                stolb[j].insert(i);
                str1[i].insert(-j);
                stolb1[j].insert(-i);
            }
            if (c == 'S') {
                x = i;
                y = j;
            }
        }
    }
    forn(i, 0, h) {
        str[i].insert(w);
        str1[i].insert(1);
    }
    forn(i, 0, w) {
        stolb[i].insert(h);
        stolb1[i].insert(1);
    }
    int l;
    cin >> l;
    string s;
    cin >> s;
    forn(i, 0, l) {
        if (s[i] == 'L') {
            int newy = *str1[x].lower_bound(-y);
            if (newy == 1) {
                cout << y << '\n';
                y = 0;
                continue;
            }
            cout << abs(newy - y) - 1 << '\n';
            y = newy + 1;
        }
        if (s[i] == 'R') {
            int newy = *str[x].lower_bound(y);
            cout << newy - y - 1 << '\n';
            y = newy - 1;
        }
        if (s[i] == 'U') {
            int newx = *stolb1[y].lower_bound(-x);
            if (newx == 1) {
                cout << x << '\n';
                x = 0;
                continue;
            }
            cout << x - abs(newx) - 1 << '\n';
            x = newx + 1;
        }
        if (s[i] == 'D') {
            int newx = *stolb[y].lower_bound(x);
            cout << newx - x - 1<< '\n';
            x = newx - 1;
        }
    }
}

int main()
{
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // _DEBUG
    cin >> h >> w >> d1;
    if (d1 == 0)
        solve();
    forn(i, 0, h) {
        forn(j, 0, w) {
            char c;
            cin >> c;
            if (c == '.') tab[i][j] = 0;
            if (c == '#') {
                tab[i][j] = 1;
            }
            if (c == 'K') tab[i][j] = 2;
            if (c == 'L') tab[i][j] = 3;
            if (c == 'S') {
                tab[i][j] = 0;
                x = i;
                y = j;
            }
        }
    }
    int L;
    cin >> L;
    string s;
    cin >> s;
    forn(i, 0, L) {
        char c;
        c = s[i];
        if (c == 'U')
            up();
        if (c == 'R')
            r();
        if (c == 'D')
            d();
        if (c == 'L')
            l();
    }
    return 0;
}

